
#include "mtk_baseDefs.h"
#include "mtk_hwAccess.h"
#include "mtk_AdapterInternal.h"
#include "mtk_hwDmaAccess.h"

#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/fs.h>

#include "mtk_pecApi.h"

extern void 
mtk_ipsec_init(
	void
);

static bool Adapter_IsInitialized = false;


static bool
Adapter_Init(
	void
)
{
    if (Adapter_IsInitialized != false)
    {
        printk("Adapter_Init: Already initialized\n");
        return true;
    }


    if (!HWPAL_DMAResource_Init(1024))
    {
		printk("HWPAL_DMAResource_Init failed\n");
       return false;
    }

    if (!Adapter_EIP93_Init())
    {
        printk("Adapter_EIP93_Init failed\n");
		return false;
    }

#ifdef ADAPTER_EIP93PE_INTERRUPTS_ENABLE
    Adapter_Interrupts_Init(29);
#endif

    Adapter_IsInitialized = true;

    return true;
}


static void
Adapter_UnInit(
	void
)
{
    if (!Adapter_IsInitialized)
    {
        printk("Adapter_UnInit: Adapter is not initialized\n");
        return;
    }

    Adapter_IsInitialized = false;



    Adapter_EIP93_UnInit();

#ifdef ADAPTER_EIP93PE_INTERRUPTS_ENABLE
    Adapter_Interrupts_UnInit();
#endif

    HWPAL_DMAResource_UnInit();
}

int
VDriver_Init(
	void
)
{
    if (!Adapter_Init())
    {
		printk("\n !Adapter_Init failed! \n");
        return -1;
    }

	if (PEC_Init(NULL) == PEC_ERROR_BAD_USE_ORDER)
	{
		printk("\n !PEC is initialized already! \n");
		return -1;
	}

	mtk_ipsec_init();
    
    return 0;   // success
}



void
VDriver_Exit(
	void
)
{
    Adapter_UnInit();
	
	PEC_UnInit();
}

MODULE_LICENSE("Proprietary");

module_init(VDriver_Init);
module_exit(VDriver_Exit);
