#ifndef _CSID_RADIUS_USER_H_
#define _CSID_RADIUS_USER_H_

#include "csid_gid.h"

#define _CFG_RADIUS_USER(x)       (CSID_GIDC_RADIUS_USER|(x))
#define _STA_RADIUS_USER(x)       (CSID_GIDS_RADIUS_USER|(x))

#define CSID_S_RADIUS_USER_ALTERED  _STA_RADIUS_USER(0x0100) //T=u8, D=0, altered
//used to trigger ALTERED
#define CSID_S_RADIUS_ADD_USER      _STA_RADIUS_USER(0x0101) //T=u8, D=0
#define CSID_S_RADIUS_DEL_USER      _STA_RADIUS_USER(0x0102) //T=u8, D=0
#define CSID_S_RADIUS_MOD_USER      _STA_RADIUS_USER(0x0103) //T=u8, D=0
#define CSID_C_RADIUS_USER_NUM      _CFG_RADIUS_USER(0x0004) //T=u32, D=0

//add user
#define CSID_C_RADIUS_ADD_USER_NAME        _CFG_RADIUS_USER(0x1000) //T=u8, D=0
#define CSID_C_RADIUS_ADD_USER_PASSWD      _CFG_RADIUS_USER(0x1001) //T=u8, D=0
#define CSID_S_RADIUS_ADD_USER_COMPLETE    _STA_RADIUS_USER(0x1102) //T=u8, D=0
#define CSID_S_RADIUS_USER_ADD             _STA_RADIUS_USER(0x1103) //T=u8, D=0

//delete user
#define CSID_C_DEL_USER_NAME        _CFG_RADIUS_USER(0x2000) //T=u8, D=0
#define CSID_S_DEL_USER_COMPLETE    _STA_RADIUS_USER(0x2101) //T=u8, D=0
#define CSID_S_RADIUS_USER_DEL      _STA_RADIUS_USER(0x2102) //T=u8, D=0

//modify user
#define CSID_C_MOD_USER_NAME_ORG    _CFG_RADIUS_USER(0x3000)  //T=str, D=""
#define CSID_C_MOD_USER_NAME        _CFG_RADIUS_USER(0x3001)  //T=str, D=""
#define CSID_C_MOD_USER_PASSWD      _CFG_RADIUS_USER(0x3002)  //T=str, D=""
#define CSID_S_MOD_USER_COMPLETE    _STA_RADIUS_USER(0x3103)  //T=u8, D=0
#define CSID_S_RADIUS_USER_MOD      _STA_RADIUS_USER(0x3104)  //T=u8, D=0

//database to store informations of users
#define BEGIN_USER      0x4001
#define BEGIN_PASSWD    0x6001
#define BEGIN_DISABLE   0x8001
#define BEGIN_ENABLE    0xA001

#define CSID_C_RADIUS_USER              _CFG_RADIUS_USER(BEGIN_USER)    //T=str, D="" , radius user name
#define CSID_C_RADIUS_PASSWD            _CFG_RADIUS_USER(BEGIN_PASSWD)  //T=str, D="" , user password
#define CSID_C_RADIUS_USER_DISABLE      _CFG_RADIUS_USER(BEGIN_DISABLE) //T=u8, D=0, disable flag 
#define CSID_C_RADIUS_USER_ENABLE       _CFG_RADIUS_USER(BEGIN_ENABLE)  //T=u8, D=1, disable flag 

#endif
