/*
 * Note: this file originally auto-generated by mib2c using
 *        $
 */

#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "AdvIPS.h"
#include "csman.h"
#include <stdio.h>
#include <string.h>


/* 
 * AdvIPS_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid AdvIPS_variables_oid[] = { 1,3,6,1,4,1,12823,3,3,9,3,1,7 };

/* 
 * variable4 AdvIPS_variables:
 *   this variable defines function callbacks and type return information 
 *   for the AdvIPS mib section 
 */

struct variable7 AdvIPS_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{ADVIPSENABLE,  ASN_INTEGER,  RWRITE,var_AdvIPS, 1,  { 1 }},
{ADVSYNFLOODINGENABLE,  ASN_INTEGER,  RWRITE, var_AdvIPS, 1,  { 2 }},
{ADVSYNFLOODINGTHRESHHOLD,  ASN_INTEGER,  RWRITE, var_AdvIPS, 1,  { 3 }},
{ADVUDPFLOODINGENABLE,  ASN_INTEGER,  RWRITE, var_AdvIPS, 1,  { 4 }},
{ADVUDPFLOODINGTHRESHHOLD,  ASN_INTEGER,  RWRITE, var_AdvIPS, 1,  { 5 }},
{ADVICMPFLOODINGENABLE,  ASN_INTEGER,  RWRITE, var_AdvIPS, 1,  { 6 }},
{ADVICMPFLOODINGTHRESHHOLD,  ASN_INTEGER,  RWRITE, var_AdvIPS, 1,  { 7 }},
{ADVPORTSCANENABLE,  ASN_INTEGER,  RWRITE, var_AdvIPS, 1,  { 8 }},
{ADVPORTSCANTHRESHHOLD,  ASN_INTEGER,  RWRITE, var_AdvIPS, 1,  { 9 }},
{ADVBLOCKIPSPOOFENABLE,  ASN_INTEGER,  RWRITE, var_AdvIPS, 1,  { 10 }},
{ADVBLOCKTCPFLAGSCANENABLE,  ASN_INTEGER,  RWRITE, var_AdvIPS, 1,  { 11 }},
{ADVLANDATTACKENABLE,  ASN_INTEGER,  RWRITE, var_AdvIPS, 1,  { 12 }},
{ADVBLOCKTEARDROPENABLE,  ASN_INTEGER,  RWRITE, var_AdvIPS, 1,  { 13 }},
{ADVBLOCKSMURFENABLE,  ASN_INTEGER,  RWRITE, var_AdvIPS, 1,  { 14 }},
{ADVBLOCKPINGOFDEATHENABLE,  ASN_INTEGER,  RWRITE, var_AdvIPS, 1,  { 15 }},
{ADVBLOCKTRACEROUTEENABLE,  ASN_INTEGER,  RWRITE, var_AdvIPS, 1,  { 16 }},
{ADVBLOCKICMPFRAGMENTENABLE,  ASN_INTEGER,  RWRITE, var_AdvIPS, 1,  { 17 }},
{ADVBLOCKSYNFRAGMENTENABLE,  ASN_INTEGER,  RWRITE, var_AdvIPS, 1,  { 18 }},
{ADVBLOCKFRAGGLEATTACKENABLE,  ASN_INTEGER,  RWRITE, var_AdvIPS, 1,  { 19 }},
{ADVIPSLOGALERT,  ASN_INTEGER,  RWRITE,var_AdvIPS, 1,  { 20 }},

};
/*    (L = length of the oidsuffix) */


/** Initializes the AdvIPS module */
void
init_AdvIPS(void)
{

    DEBUGMSGTL(("AdvIPS", "Initializing\n"));

    /* register ourselves with the agent to handle our mib tree */
    REGISTER_MIB("AdvIPS", AdvIPS_variables, variable7,
               AdvIPS_variables_oid);

    /* place any other initialization junk you need here */
}

/*
 * var_AdvIPS():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_AdvIPS(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    int fd=0;

    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case ADVIPSENABLE:
        *write_method = write_AdvIPSEnable;
	read_csman(fd,0x00150600,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVSYNFLOODINGENABLE:
        *write_method = write_AdvSYNFloodingEnable;
	read_csman(fd,0x00150601,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVSYNFLOODINGTHRESHHOLD:
        *write_method = write_AdvSYNFloodingThreshhold;
	read_csman(fd,0x00150602,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVUDPFLOODINGENABLE:
        *write_method = write_AdvUDPFloodingEnable;
	read_csman(fd,0x00150607,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVUDPFLOODINGTHRESHHOLD:
        *write_method = write_AdvUDPFloodingThreshhold;
	read_csman(fd,0x00150608 ,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVICMPFLOODINGENABLE:
        *write_method = write_AdvICMPFloodingEnable;
	read_csman(fd,0x00150604,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVICMPFLOODINGTHRESHHOLD:
        *write_method = write_AdvICMPFloodingThreshhold;
	read_csman(fd,0x00150605,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVPORTSCANENABLE:
        *write_method = write_AdvPortScanEnable;
	read_csman(fd,0x0015060a ,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVPORTSCANTHRESHHOLD:
        *write_method = write_AdvPortScanThreshhold;
	read_csman(fd,0x0015060b,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVBLOCKIPSPOOFENABLE:
        *write_method = write_AdvBlockIPSpoofEnable;
	read_csman(fd,0x00150618,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVBLOCKTCPFLAGSCANENABLE:
        *write_method = write_AdvBlockTCPFlagScanEnable;
	read_csman(fd,0x00150617,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVLANDATTACKENABLE:
        *write_method = write_AdvLandAttackEnable;
	read_csman(fd,0x0015060e  ,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVBLOCKTEARDROPENABLE:
        *write_method = write_AdvBlockTearDropEnable;
	read_csman(fd,0x00150616  ,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVBLOCKSMURFENABLE:
        *write_method = write_AdvBlockSmurfEnable;
	read_csman(fd,0x0015060c ,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVBLOCKPINGOFDEATHENABLE:
        *write_method = write_AdvBlockPingofDeathEnable;
	read_csman(fd,0x00150612 ,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVBLOCKTRACEROUTEENABLE:
        *write_method = write_AdvBlockTraceRouteEnable;
	read_csman(fd,0x00150615,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVBLOCKICMPFRAGMENTENABLE:
        *write_method = write_AdvBlockICMPFragmentEnable;
	read_csman(fd,0x00150613 ,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVBLOCKSYNFRAGMENTENABLE:
        *write_method = write_AdvBlockSYNFragmentEnable;
	read_csman(fd,0x00150614 ,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVBLOCKFRAGGLEATTACKENABLE:
        *write_method = write_AdvBlockFraggleAttackEnable;
	read_csman(fd,0x0015060f,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case ADVIPSLOGALERT:
        *write_method = write_AdvIPSLogAlert;
	read_csman(fd,0x00150620,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}





int
write_AdvIPSEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x00150600,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvSYNFloodingEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x00150601,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvSYNFloodingThreshhold(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x00150602,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvUDPFloodingEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x00150607 ,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvUDPFloodingThreshhold(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x00150608 ,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvICMPFloodingEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x00150604 ,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvICMPFloodingThreshhold(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x00150605,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvPortScanEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x0015060a ,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvPortScanThreshhold(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x0015060b,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvBlockIPSpoofEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x00150618,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvBlockTCPFlagScanEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x00150617 ,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvLandAttackEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x0015060e  ,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvBlockTearDropEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x00150616 ,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvBlockSmurfEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x0015060c  ,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvBlockPingofDeathEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x00150612  ,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvBlockTraceRouteEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x00150615,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvBlockICMPFragmentEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x00150613 ,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvBlockSYNFragmentEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x00150614 ,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvBlockFraggleAttackEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x0015060f,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvIPSLogAlert(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
             	{
             		int fd=0;
              	write_csman(fd,0x00150620,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
             	}
          break;
    }
    return SNMP_ERR_NOERROR;
}