/*
 * Note: this file originally auto-generated by mib2c using
 *        $
 */

#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "csman.h"
#include "SysACInfo.h"
#include <stdio.h>
#include <string.h>

/* 
 * SysACInfo_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid SysACInfo_variables_oid[] = { 1,3,6,1,4,1,12823,3,3,9,5,6,1 };

/* 
 * variable4 SysACInfo_variables:
 *   this variable defines function callbacks and type return information 
 *   for the SysACInfo mib section 
 */

struct variable7 SysACInfo_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{SYSMODELNAME,  ASN_OCTET_STR,  RONLY,var_SysACInfo, 1,  { 1 }},
{SYSUPTIME,  ASN_OCTET_STR,  RONLY,var_SysACInfo, 1,  { 2 }},
{SYSWLANMAC,  ASN_OCTET_STR,  RONLY,var_SysACInfo, 1,  { 3}},
{SYSLANMAC , ASN_OCTET_STR,  RONLY,var_SysACInfo, 1,  { 4 }},
{SYSWANMAC,  ASN_OCTET_STR,  RONLY,var_SysACInfo, 1,  { 5 }},
{SYSCOUNTRYREGIONAP1,  ASN_INTEGER,  RONLY,var_SysACInfo, 1,  { 6 }},
{SYSCOUNTRYREGIONAP2,  ASN_INTEGER,  RONLY,var_SysACInfo, 1,  { 7 }},
{SYSSSIDAP1,  ASN_OCTET_STR,  RONLY,var_SysACInfo, 1,  { 8 }},
{SYSSSIDAP2,  ASN_OCTET_STR,  RONLY,var_SysACInfo, 1,  { 9 }},
{SYSRSSIAP1,  ASN_INTEGER,  RONLY,var_SysACInfo, 1,  { 10 }},
{SYSRSSIAP2,  ASN_INTEGER,  RONLY,var_SysACInfo, 1,  { 11 }},
{SYSFWVERSION,  ASN_OCTET_STR,  RONLY,var_SysACInfo, 1,  { 12 }},
{SYSAP1UPSTREAM,  ASN_INTEGER,  RONLY,var_SysACInfo, 1,  { 13 }},
{SYSAP1DOWNSTREAM,  ASN_INTEGER,  RONLY,var_SysACInfo, 1,  { 14 }},
{SYSAP2UPSTREAM,  ASN_INTEGER,  RONLY,var_SysACInfo, 1,  { 15 }},
{SYSAP2DOWNSTREAM,  ASN_INTEGER,  RONLY,var_SysACInfo, 1,  { 16 }},
{SYSAPROMID,  ASN_OCTET_STR,  RONLY,var_SysACInfo, 1,  { 17 }},
{SYSAP24TRAFFICMBPS,  ASN_OCTET_STR,  RONLY,var_SysACInfo, 1,  { 18 }},
{SYSAP50TRAFFICMBPS,  ASN_OCTET_STR,  RONLY,var_SysACInfo, 1,  { 19 }}


};
/*    (L = length of the oidsuffix) */


/** Initializes the SysACInfo module */
void
init_SysACInfo(void)
{

    DEBUGMSGTL(("SysACInfo", "Initializing\n"));

    /* register ourselves with the agent to handle our mib tree */
    REGISTER_MIB("SysACInfo", SysACInfo_variables, variable7,
               SysACInfo_variables_oid);

    /* place any other initialization junk you need here */
}

/*
 * var_SysACInfo():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_SysACInfo(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    int fd=0;
    static long vap1,vap2,vap3,vap4,vap5,vap6,vap7,vap8;
	
    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSMODELNAME:
	{
		memset(string,0,sizeof(string));
		read_csman(fd,0x8000420c,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    	}
    case SYSUPTIME:
	{
		unsigned char info_time[128];
		memset(info_time,0,sizeof(info_time));
		system("uptime | cut -f1 -d 'u' > /tmp/snmp_up_time");

		FILE *fp;
		char buf[128];
		if((fp = fopen("/tmp/snmp_up_time","r")) != NULL){
			fgets(info_time, sizeof(info_time), fp);
			sscanf(info_time,"%s",info_time);
		}
		fclose(fp);
		
		*var_len = strlen(info_time);
		system("rm -rf /tmp/snmp_up_time");
		return (unsigned char *) info_time;
    	}
    case SYSWLANMAC:
	{
		memset(string,0,sizeof(string));
		read_csman(fd,0x8000f3a1,string,sizeof(string),TYPE_MAC);
		*var_len = 6;
		return (unsigned char *) string;
    	}
    case SYSLANMAC:
	{
		memset(string,0,sizeof(string));
		read_csman(fd,0x8000f341,string,sizeof(string),TYPE_MAC);
		*var_len = 6;
		return (unsigned char *) string;
    	}
    case SYSWANMAC:
	{
		memset(string,0,sizeof(string));
		read_csman(fd,0x8000f371,string,sizeof(string),TYPE_MAC);
		*var_len = 6;
		return (unsigned char *) string;
    	}
    case SYSCOUNTRYREGIONAP1:
	{
		read_csman(fd,0x0019a403,&long_ret,sizeof(int),TYPE_U8);
		return (unsigned char *) &long_ret;
	}
    case SYSCOUNTRYREGIONAP2:
	{	
		int dualband;
		
		read_csman(fd,0x0019a404,&long_ret,sizeof(int),TYPE_U8);
		read_csman(fd,0x00010087,&dualband,sizeof(int),TYPE_U8);

		if(dualband == 0)
			long_ret = 255;
		
		return (unsigned char *) &long_ret;
	}
    case SYSSSIDAP1:
   	{
		memset(string,0,sizeof(string));
		read_csman(fd,0x00190400,string,sizeof(string),TYPE_STR);
		
		if(strlen(string) < 2){
			memset(string,0,sizeof(string));
			strcpy(string,"default ");
			*var_len = strlen(string)-1;
			return (unsigned char *) string;
		}
		else{
			*var_len = strlen(string)-1;
			return (unsigned char *) string;
		}
	}
    case SYSSSIDAP2:
   	{
		memset(string,0,sizeof(string));
		read_csman(fd,0x00440400,string,sizeof(string),TYPE_STR);
		
		if(strlen(string) < 2){
			memset(string,0,sizeof(string));
			strcpy(string,"default ");
			*var_len = strlen(string)-1;
			return (unsigned char *) string;
		}
		else{
			*var_len = strlen(string)-1;
			return (unsigned char *) string;
		}
	}
    case SYSRSSIAP1:
	system("stainfo");
	read_csman(fd, 0x80196600,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case SYSRSSIAP2:
	system("stainfo2");
	read_csman(fd, 0x80446600 ,&long_ret,sizeof(unsigned int),TYPE_U32);
	return (unsigned char *) &long_ret;
    case SYSFWVERSION:
   	{
		memset(string,0,sizeof(string));
		read_csman(fd,0x80004208,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
	}
    case SYSAP1UPSTREAM:
	{
		vap1=vap2=vap3=vap4=vap5=vap6=vap7=vap8=long_ret=0;

		system("apinfo24");
		read_csman(fd,0x80198050,&vap1,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80198051,&vap2,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80198052,&vap3,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80198053,&vap4,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80198054,&vap5,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80198055,&vap6,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80198056,&vap7,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80198057,&vap8,sizeof(unsigned int),TYPE_U32);

		long_ret = vap1+vap2+vap3+vap4+vap5+vap6+vap7+vap8;

		return (unsigned char *) &long_ret;
    	}
    case SYSAP1DOWNSTREAM:
	{
		vap1=vap2=vap3=vap4=vap5=vap6=vap7=vap8=long_ret=0;

		system("apinfo24");
		read_csman(fd,0x80198040,&vap1,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80198041,&vap2,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80198042,&vap3,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80198043,&vap4,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80198044,&vap5,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80198045,&vap6,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80198046,&vap7,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80198047,&vap8,sizeof(unsigned int),TYPE_U32);

		long_ret = vap1+vap2+vap3+vap4+vap5+vap6+vap7+vap8;

		return (unsigned char *) &long_ret;
    	}
    case SYSAP2UPSTREAM:
	{
		int dualband=0;
		vap1=vap2=vap3=vap4=vap5=vap6=vap7=vap8=long_ret=0;

		read_csman(fd,0x00010087,&dualband,sizeof(int),TYPE_U8);

		if(dualband == 1)	
			system("apinfo50");
			
		read_csman(fd,0x80448050,&vap1,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80448051,&vap2,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80448052,&vap3,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80448053,&vap4,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80448054,&vap5,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80448055,&vap6,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80448056,&vap7,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80448057,&vap8,sizeof(unsigned int),TYPE_U32);

		long_ret = vap1+vap2+vap3+vap4+vap5+vap6+vap7+vap8;
		return (unsigned char *) &long_ret;
    	}
    case SYSAP2DOWNSTREAM:
	{
		int dualband=0;
		vap1=vap2=vap3=vap4=vap5=vap6=vap7=vap8=long_ret=0;

		read_csman(fd,0x00010087,&dualband,sizeof(int),TYPE_U8);

		if(dualband == 1)	
			system("apinfo50");
		
		read_csman(fd,0x80448040,&vap1,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80448041,&vap2,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80448042,&vap3,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80448043,&vap4,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80448044,&vap5,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80448045,&vap6,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80448046,&vap7,sizeof(unsigned int),TYPE_U32);
		read_csman(fd,0x80448047,&vap8,sizeof(unsigned int),TYPE_U32);

		long_ret = vap1+vap2+vap3+vap4+vap5+vap6+vap7+vap8;
		return (unsigned char *) &long_ret;
    	}
    case SYSAPROMID:
	{
		memset(string,0,sizeof(string));
		read_csman(fd,0x80004210 ,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;		
    	}
    case SYSAP24TRAFFICMBPS:
	{
		int i=0;
		char tmp_ap_tx[256],tmp_ap_rx[256],tmp_vap_tx[8][256],tmp_vap_rx[8][256];
		
		memset(string,0,sizeof(string));
		memset(tmp_ap_tx,0,sizeof(tmp_ap_tx));
		memset(tmp_ap_rx,0,sizeof(tmp_ap_rx));

		for(i=0;i<8;i++)
		{
			memset(tmp_vap_tx[i],0,sizeof(tmp_vap_tx[i]));
			memset(tmp_vap_rx[i],0,sizeof(tmp_vap_rx[i]));
		}

		read_csman(fd,0x80773000,tmp_ap_tx,sizeof(tmp_ap_tx),TYPE_STR);
		read_csman(fd,0x80773001,tmp_ap_rx,sizeof(tmp_ap_rx),TYPE_STR);
		read_csman(fd,0x80773010,tmp_vap_tx[0],sizeof(tmp_vap_tx[0]),TYPE_STR);
		read_csman(fd,0x80773011,tmp_vap_tx[1],sizeof(tmp_vap_tx[1]),TYPE_STR);
		read_csman(fd,0x80773012,tmp_vap_tx[2],sizeof(tmp_vap_tx[2]),TYPE_STR);
		read_csman(fd,0x80773013,tmp_vap_tx[3],sizeof(tmp_vap_tx[3]),TYPE_STR);
		read_csman(fd,0x80773014,tmp_vap_tx[4],sizeof(tmp_vap_tx[4]),TYPE_STR);
		read_csman(fd,0x80773015,tmp_vap_tx[5],sizeof(tmp_vap_tx[5]),TYPE_STR);
		read_csman(fd,0x80773016,tmp_vap_tx[6],sizeof(tmp_vap_tx[6]),TYPE_STR);
		read_csman(fd,0x80773017,tmp_vap_tx[7],sizeof(tmp_vap_tx[7]),TYPE_STR);
		read_csman(fd,0x80773020,tmp_vap_rx[0],sizeof(tmp_vap_rx[0]),TYPE_STR);
		read_csman(fd,0x80773021,tmp_vap_rx[1],sizeof(tmp_vap_rx[1]),TYPE_STR);
		read_csman(fd,0x80773022,tmp_vap_rx[2],sizeof(tmp_vap_rx[2]),TYPE_STR);
		read_csman(fd,0x80773023,tmp_vap_rx[3],sizeof(tmp_vap_rx[3]),TYPE_STR);
		read_csman(fd,0x80773024,tmp_vap_rx[4],sizeof(tmp_vap_rx[4]),TYPE_STR);
		read_csman(fd,0x80773025,tmp_vap_rx[5],sizeof(tmp_vap_rx[5]),TYPE_STR);
		read_csman(fd,0x80773026,tmp_vap_rx[6],sizeof(tmp_vap_rx[6]),TYPE_STR);
		read_csman(fd,0x80773027,tmp_vap_rx[7],sizeof(tmp_vap_rx[7]),TYPE_STR);

		sprintf(string,"%s,%s@%s,%s@%s,%s@%s,%s@%s,%s@%s,%s@%s,%s@%s,%s@%s,%s",\
			tmp_ap_tx,tmp_ap_rx,tmp_vap_tx[0],tmp_vap_rx[0],tmp_vap_tx[1],tmp_vap_rx[1],tmp_vap_tx[2],\
			tmp_vap_rx[2],tmp_vap_tx[3],tmp_vap_rx[3],tmp_vap_tx[4],tmp_vap_rx[4]\
			,tmp_vap_tx[5],tmp_vap_rx[5],tmp_vap_tx[6],tmp_vap_rx[6],tmp_vap_tx[7],tmp_vap_rx[7]);
		
		*var_len = strlen(string);
		return (unsigned char *) string;		
    	}
    case SYSAP50TRAFFICMBPS:
	{
		int i=0;
		char tmp_ap_tx[256],tmp_ap_rx[256],tmp_vap_tx[8][256],tmp_vap_rx[8][256];
	
		memset(string,0,sizeof(string));
		for(i=0;i<8;i++)
		{
			memset(tmp_vap_tx[i],0,sizeof(tmp_vap_tx[i]));
			memset(tmp_vap_rx[i],0,sizeof(tmp_vap_rx[i]));
		}

		read_csman(fd,0x80783000,tmp_ap_tx,sizeof(tmp_ap_tx),TYPE_STR);
		read_csman(fd,0x80783001,tmp_ap_rx,sizeof(tmp_ap_rx),TYPE_STR);
		read_csman(fd,0x80783010,tmp_vap_tx[0],sizeof(tmp_vap_tx[0]),TYPE_STR);
		read_csman(fd,0x80783011,tmp_vap_tx[1],sizeof(tmp_vap_tx[1]),TYPE_STR);
		read_csman(fd,0x80783012,tmp_vap_tx[2],sizeof(tmp_vap_tx[2]),TYPE_STR);
		read_csman(fd,0x80783013,tmp_vap_tx[3],sizeof(tmp_vap_tx[3]),TYPE_STR);
		read_csman(fd,0x80783014,tmp_vap_tx[4],sizeof(tmp_vap_tx[4]),TYPE_STR);
		read_csman(fd,0x80783015,tmp_vap_tx[5],sizeof(tmp_vap_tx[5]),TYPE_STR);
		read_csman(fd,0x80783016,tmp_vap_tx[6],sizeof(tmp_vap_tx[6]),TYPE_STR);
		read_csman(fd,0x80783017,tmp_vap_tx[7],sizeof(tmp_vap_tx[7]),TYPE_STR);
		read_csman(fd,0x80783020,tmp_vap_rx[0],sizeof(tmp_vap_rx[0]),TYPE_STR);
		read_csman(fd,0x80783021,tmp_vap_rx[1],sizeof(tmp_vap_rx[1]),TYPE_STR);
		read_csman(fd,0x80783022,tmp_vap_rx[2],sizeof(tmp_vap_rx[2]),TYPE_STR);
		read_csman(fd,0x80783023,tmp_vap_rx[3],sizeof(tmp_vap_rx[3]),TYPE_STR);
		read_csman(fd,0x80783024,tmp_vap_rx[4],sizeof(tmp_vap_rx[4]),TYPE_STR);
		read_csman(fd,0x80783025,tmp_vap_rx[5],sizeof(tmp_vap_rx[5]),TYPE_STR);
		read_csman(fd,0x80783026,tmp_vap_rx[6],sizeof(tmp_vap_rx[6]),TYPE_STR);
		read_csman(fd,0x80783027,tmp_vap_rx[7],sizeof(tmp_vap_rx[7]),TYPE_STR);

		sprintf(string,"%s,%s@%s,%s@%s,%s@%s,%s@%s,%s@%s,%s@%s,%s@%s,%s@%s,%s",\
			tmp_ap_tx,tmp_ap_rx,tmp_vap_tx[0],tmp_vap_rx[0],tmp_vap_tx[1],tmp_vap_rx[1],tmp_vap_tx[2],\
			tmp_vap_rx[2],tmp_vap_tx[3],tmp_vap_rx[3],tmp_vap_tx[4],tmp_vap_rx[4]\
			,tmp_vap_tx[5],tmp_vap_rx[5],tmp_vap_tx[6],tmp_vap_rx[6],tmp_vap_tx[7],tmp_vap_rx[7]);
		
		*var_len = strlen(string);
		return (unsigned char *) string;		
    	}
     
    default:
      ERROR_MSG("");
    }
    return NULL;
}




