/*
 * Note: this file originally auto-generated by mib2c using
 *        $
 */

#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "csman.h"
#include "SysTRAPSet.h"
#include <stdio.h>
#include <string.h>


oid snmptrap_oid[];
int snmptrap_oid_len;

#define OID_LENGTH(x)  (sizeof(x)/sizeof(x[0]))

struct statistic_mib
{
	unsigned long	WanTransmit;
	unsigned long	WanReceive;
	unsigned long	LanTransmit;
	unsigned long	LanReceive;
	unsigned long	WlanTransmit;
	unsigned long	WlanReceive;
	unsigned long	TrashData;
};

struct statistic_mib ap_statistic;

static int linux_read_statistic()
{
	char line [1024];

  	system("traffic_stat > /tmp/trap_ap_statistic");

  	FILE *in = fopen ("/tmp/trap_ap_statistic", "r");

  	if (! in)	return -1;

 	while (line == fgets (line, sizeof(line), in))
    	{
      		if (5 == sscanf (line, "LAN %lu %lu %lu %lu %lu\n",
			&ap_statistic.TrashData, &ap_statistic.LanTransmit,
			&ap_statistic.TrashData, &ap_statistic.TrashData, &ap_statistic.LanReceive))
		break;
    	}

  	while (line == fgets (line, sizeof(line), in))
    	{
      		if (5 == sscanf (line, "WLAN %lu %lu %lu %lu %lu\n",
			&ap_statistic.TrashData, &ap_statistic.WlanTransmit,
			&ap_statistic.TrashData, &ap_statistic.TrashData, &ap_statistic.WlanReceive))
		break;
  	 }

  	fclose (in);	
	system("rm -rf /tmp/ap_snmp_statistic");
	return 0;
}

int
send_SysAPControllerTrafficStatic_trap( void )
{
    struct variable_list  *var_list = NULL;
    const oid SysAPControllerTrafficStatic_oid[] = { 1,3,6,1,4,1,12823,3,3,9,5,7,1};
    const oid SysAPControllerTrafficStaticInfo_oid[] = { 1,3,6,1,4,1,12823,3,3,9,5,7,10,0 };
    const oid SysAPControllerUserTrafficInfo_oid[] = { 1,3,6,1,4,1,12823,3,3,9,5,7,11,0 };
    const oid SysAPControllerUserTxRxInfo_oid[] = { 1,3,6,1,4,1,12823,3,3,9,5,7,12,0 };

    int fd=0,ap_traffic_enable=0;
    int ap_traffic_len;	
    char ap_traffic[2048];
	
    memset(ap_traffic,0,sizeof(ap_traffic));

	
    /*Read CSID to decided which function must enable*/
    read_csman(fd,0x00760007 ,&ap_traffic_enable,sizeof(unsigned int),TYPE_U32);

    /*Get WLAN Tx Rx*/
    if(ap_traffic_enable){
    	linux_read_statistic();
    	sprintf(ap_traffic,"%d,%d",ap_statistic.LanTransmit,ap_statistic.LanReceive);
    }
    ap_traffic_len = strlen(ap_traffic);

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
        snmptrap_oid, snmptrap_oid_len,
        ASN_OBJECT_ID,
        SysAPControllerTrafficStatic_oid, sizeof(SysAPControllerTrafficStatic_oid));
    
    /*
     * Add any objects from the trap definition
     */

    /*AP Traffic Statistic Tx/Rx packet */
    if(ap_traffic_enable){
    	snmp_varlist_add_variable(&var_list,
		SysAPControllerTrafficStaticInfo_oid, OID_LENGTH(SysAPControllerTrafficStaticInfo_oid),
        	ASN_OCTET_STR, ap_traffic, ap_traffic_len);
    }

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap( var_list );
    snmp_free_varbind( var_list );

    return SNMP_ERR_NOERROR;
}
