/*
 * Copyright(c) 2006-2007, Works Systems, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 3. Neither the name of the vendors nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


/*
 * Include head file.
 */

#include "handler.h"
#include "../auth/auth.h"
//#include "flashbuf.h"

//libupgbuf.so
int get_flash_free_size()
{
    printf("Call get flash free size function!\n");
    return 0x1200000; 
    /*
    char buf[65],test[100];
    memset(buf,'\0',sizeof(buf));
    int fd = open_csman(NULL, 0);
    read_csman(fd, CSID_S_TR069_DEVINFO_MODELNAME, buf, sizeof(buf),CSM_R_ZERO);
    close_csman(fd);
    sprintf(test,"echo colin DEVINFO_MODELNAME=%s >>/tmp/colin",buf);
    system(test);
    memset(test,'\0',sizeof(test));
    if(strcmp(buf,"BDG761AM_0P1")==0)
      return 0x1200000; 
    else
      return 0x1000000;
      */
}

int parse_data(char *image_start_ptr, int bufsize, int dl_type)
{
    printf("Call parse data function!\nThe size is %d\n", bufsize);

    int result = 0;

    if(dl_type == 0)
    { 
        result = 1;
    }
    else if (dl_type == 1)
    {
        result = 2;
    }
    else if (dl_type == 2)
    {
        result = 3;
    }

    return result;
}

int dev_flashimage_func(char *imageptr, int imagelen) 
{
	int handle, ret;
	char buf[50];	
	
	int (*open_upgbuf)(int) = NULL;
	int (*close_upgbuf)(int) = NULL;
	int (*write_upgbuf)(int,const void *,size_t) = NULL;
	
  flash_handle = dlopen("/lib/libupgbuf.so", RTLD_LAZY);
	open_upgbuf = dlsym(flash_handle, "open_upgbuf");
	close_upgbuf = dlsym(flash_handle, "close_upgbuf");
	write_upgbuf = dlsym(flash_handle, "write_upgbuf");
    printf("Call flashimage function!\n");
	
	printf("in dev_flashimage_func(): Call flashimage function!\n");
	sprintf(buf,"echo 'imagelen = %d' >> /tmp/log_cpe", imagelen);

	system(buf);
	/*
    	FILE *fp = NULL;
    	fp = fopen(DOWNLOAD_IMAGE_PATH, "w+");
    	if(fp == NULL)
    	{
       		printf("write image failed\n");
        	return -1;
    	}
    	fwrite(imageptr, 1, imagelen, fp);
    	fclose(fp);
    */

	handle=open_upgbuf(0);
	if(handle < 0)
	{
		printf("Open upgbuf failed\n");
        return -1;
	}

	ret=write_upgbuf(handle, imageptr, imagelen);
	sprintf(buf,"echo 'ret = %d' >> /tmp/log_cpe", ret);

	system(buf);

	if(ret<0)
	{
		printf("write image failed\n");
		close_upgbuf(handle);
		return -1;
	}
	close_upgbuf(handle);
	
    printf("flash image successful\n");

    return 0;
}

int reboot_dev()
{
    printf("Call reboot function!\n");
    sleep(2); //VIP, Wait for system stable.
	system("reboot");
    return 0;
}

    /*
     *********************************************************************
     * Function name: password_cb
     * Description: password callback function
     * Parameter: char *buf: the buffer for password; size: the buffer size; rwflag: read or write; userdata: user's data
     * Return value: the length of the password
     *********************************************************************
    */
 /*   
#ifdef USE_SSL    
    static int password_cb(char *buf, int size, int rwflag, void *userdata)
    {
    	const char *pass = (const char *)userdata;
    	int pass_len = strlen(pass);
                                                                                                 
    	if (pass_len > size)
            return FAIL;
                                                                                                 
    	strncpy(buf, pass, pass_len);
                                                                                                 
    	return pass_len;
    }
*/
    /*
     *********************************************************************
     * Function name: verify_cb
     * Description: verify cert callback function
     * Parameter: int ok: the cert verify is OK or not; X509_STORE_CTX *stor: the pointer point to the context
     * Return value: 0 or 1
     *********************************************************************
    */
   /* 
    static int verify_cb(int ok, X509_STORE_CTX *store)
    {
        char data[256];
        if(!ok)
        {       
            LOG(m_comm, DEBUG, "in verify callback\n");

            SSL_INIT_ERR = 1;
            X509 *cert = X509_STORE_CTX_get_current_cert(store);
            int depth = X509_STORE_CTX_get_error_depth(store);
            int err = X509_STORE_CTX_get_error(store);

            LOG(m_comm, DEBUG, "Error with certificate at depth: %i\n", depth);

            X509_NAME_oneline(X509_get_issuer_name(cert), data, 256);
            LOG(m_comm, DEBUG, " issuer = %s\n", data);

            X509_NAME_oneline(X509_get_subject_name(cert), data, 256);
            LOG(m_comm, DEBUG, " subject = %s\n", data);

            LOG(m_comm, DEBUG, " err %i:%s\n", err, X509_verify_cert_error_string(err));
        }

        return ok;
    }
                                                                                                 
#endif
*/
/*
 *********************************************************************
 * Function name: ssl_auth
 * Description: try connect to ACS by SSL and do the authentication
 * Parameter: char *_ip: the ip address of server; int _port: the port of server; int *p_sockfd: the pointer point to the socket; SSL **p_ssl: the pointer point to the pointer point to the ssl; SSL_CTX **p_ctx: the pointer point to the pointer point to the ssl context; char *ca_path: the ca certificate path; char *client_path: the client certificate path; char *key_path: the key path; int *p_flag: the pointer point to the connect mode
 * Return value: 0:SUCCESS  -1:FAIL
 *********************************************************************
*/
#ifdef USE_SSL
int ssl_auth(char * _ip, int _port, int *p_sockfd, SSL **p_ssl, SSL_CTX **p_ctx, char *ca_path, char *client_path, char *key_path, int *p_flag)
{
    int res;

    if((res = init_socket_ssl_mode(_ip, _port, p_sockfd, p_ssl, p_ctx, ca_path, client_path, key_path)) != SUCCESS)
    {
        if(res == COMM_SSL_ERROR)
        {
            close(*p_sockfd);
           // LOG(m_comm, ERROR, "TCP connect in ssl port failed\n");
                
            if((*p_sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
            {
               // LOG(m_comm, ERROR, "socket() failure.\n");
                return FAIL;
            }

            *p_flag = 0;
			    
            return FAIL;
        }
        else if(SSL_INIT_ERR == 1)
        {
            //reset scoket
            if(ssl_new_flag)
                SSL_free(*p_ssl);
            if(ctx_new_flag)
                SSL_CTX_free(*p_ctx);
            close(*p_sockfd);
                               
            if((*p_sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
            {
               // LOG(m_comm, ERROR, "socket() failure.\n");
                return FAIL;
            }                                                                 
           // LOG(m_comm, ERROR, "init SSL failure.\n");
            *p_flag = 0;
            return FAIL;
        }
        else
        {
            //LOG(m_comm, DEBUG, "init ssl first failed, start to connect with SSLv3\n");

            //free ssl res
            if(ssl_new_flag)
                SSL_free(*p_ssl);
            if(ctx_new_flag)
                SSL_CTX_free(*p_ctx);
            close(*p_sockfd);

            if((*p_sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
            {
              //  LOG(m_comm, ERROR, "socket() failure.\n");
                return FAIL;
            }

            if(init_socket_sslv3_mode(_ip, _port, p_sockfd, p_ssl, p_ctx, ca_path, client_path, key_path) != SUCCESS)
            {
               // LOG(m_comm, DEBUG, "init ssl second failed\n");
                /*if(SSL_INIT_ERR == 1)
                {
                    //reset scoket
                    close(*p_sockfd);
                    *p_sockfd = socket(AF_INET, SOCK_STREAM, 0);
                                                                                                 
                    LOG(m_comm, ERROR, "init SSL failure.\n");
                    *p_flag = 0;
                    return FAIL;
                }
                else
                {*/
                   // LOG(m_comm, DEBUG, "start to connect with TLSv1\n");
        	  
                    //free ssl res
                    if(ssl_new_flag)
                        SSL_free(*p_ssl);
                    if(ctx_new_flag)
                        SSL_CTX_free(*p_ctx);
                    close(*p_sockfd);

                    if((*p_sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
                    {
                       // LOG(m_comm, ERROR, "socket() failure.\n");
                        return FAIL;
                    }

                    if(init_socket_tlsv1_mode(_ip, _port, p_sockfd, p_ssl, p_ctx, ca_path, client_path, key_path) != SUCCESS)
                    {
                        //free ssl res
                        if(ssl_new_flag)
                            SSL_free(*p_ssl);
                        if(ctx_new_flag)
                            SSL_CTX_free(*p_ctx);
                        //reset scoket
                        close(*p_sockfd);
                        *p_sockfd = socket(AF_INET, SOCK_STREAM, 0);
			
                       // LOG(m_comm, ERROR, "init SSL failure.\n");
                        *p_flag = 0;
                        return FAIL;
                    }
                    else
                    {
                        //LOG(m_comm, DEBUG, "init SSL ok.\n");
                       	*p_flag = 1;
                        return SUCCESS;
                    }
                //}
            }
            else
            {
               // LOG(m_comm, DEBUG, "init SSL ok.\n");
                *p_flag = 1;
                return SUCCESS;
            }
        }
    }
    else 
    {
        //LOG(m_comm, DEBUG, "init SSL ok.\n");
        *p_flag = 1;
        return SUCCESS;
    }

    return SUCCESS;
}
#endif
/*
 *********************************************************************
 * Function name: init_socket_ssl_mode
 * Description: int and connect to ssl port with sslv2
 * Parameter: char *_ip: the ip address of server; int _port: the port of server; int *p_sockfd: the pointer point to the socket; SSL **p_ssl: the pointer point to the pointer point to the ssl; SSL_CTX **p_ctx: the pointer point to the pointer point to the ssl context; char *ca_path: the ca certificate path; char *client_path: the client certificate path; char *key_path: the key path
 * Return value: 0:SUCCESS  -1:FAIL
 *********************************************************************
*/
#ifdef USE_SSL
    int init_socket_ssl_mode(char * _ip, int _port, int *p_sockfd, SSL **p_ssl, SSL_CTX **p_ctx, char *ca_path, char *client_path, char *key_path)
    {
        int res;
        SSL_INIT_ERR = 0;

        struct timeval timeout;
        fd_set fds;
        int errlen;
        int error;
        unsigned long fc;

        struct sockaddr_in dest;

        bzero(&dest, sizeof(&dest));

        ssl_new_flag = 0;
        ctx_new_flag = 0;

        dest.sin_family = AF_INET;
        dest.sin_addr.s_addr = inet_addr(_ip);
        dest.sin_port = htons(_port);
        //LOG(m_comm, DEBUG, "set SSL port %d and ip %s.\n", _port, _ip);
		
        fc = 1;
        if(ioctl(*p_sockfd, FIONBIO, &fc) == -1)
        {
            //LOG(m_comm, ERROR, "ioctl error.\n");
            return FAIL;
        }

        if(connect(*p_sockfd, (struct sockaddr *)&dest, sizeof(struct sockaddr)) == -1)
        {
	    if(errno != EINPROGRESS) {
              // LOG(m_comm, DEBUG, "Network is unreachable.\n");
               return FAIL;
            }

            errlen = sizeof(int);
            FD_ZERO(&fds);
            FD_SET(*p_sockfd, &fds);
            timeout.tv_sec = TIME_OUT;
            timeout.tv_usec = 0;
                                                                                                 
            if((res = select(*p_sockfd + 1, NULL, &fds, NULL, &timeout)) > 0)
            {
                getsockopt(*p_sockfd, SOL_SOCKET, SO_ERROR, &error, (socklen_t *)&errlen);
                if(error == 0)
                {
                   // LOG(m_comm, DEBUG, "In select()\n");
                }
                else
                {
                  //  LOG(m_comm, ERROR, "error\n");
                    return FAIL;
                }
            }
            else
            {
              //  LOG(m_comm, ERROR, "Connect Timeout\n");
                //continue;
                return COMM_SSL_ERROR;
            }
        }
        else
        {
          //  LOG(m_comm, DEBUG, "TCP connected\n");
        }
		
        fc = 0;    
        if(ioctl(*p_sockfd, FIONBIO, &fc) == -1)
        {
          //  LOG(m_comm, ERROR, "ioctl error\n");
            return FAIL;
        }
		
        SSL_load_error_strings();
        if(SSL_library_init() != 1)
        {
          //  LOG(m_comm, ERROR, "SSL lib init failure.\n");
            SSL_INIT_ERR = 1;
            return FAIL;
        }
        LOG(m_comm, DEBUG, "SSL lib init ok.\n");
			
        if((*p_ctx = SSL_CTX_new(SSLv23_method())) == NULL )
        {
           // LOG(m_comm, ERROR, "create SSL context failure.\n");
            SSL_INIT_ERR = 1;
            return FAIL;
        }
       // LOG(m_comm, DEBUG, "create SSL context ok.\n");
        
        ctx_new_flag = 1;

        SSL_CTX_set_verify(*p_ctx, SSL_VERIFY_PEER, verify_cb);
        SSL_CTX_set_verify_depth(*p_ctx, SSL_DEPTH);
        SSL_CTX_set_options(*p_ctx, SSL_OP_NO_SSLv2);
       // LOG(m_comm, DEBUG, "set verify mode to SSL_VERIFY_PEER mode.SSL_DEPTH=%d\n", SSL_DEPTH);
		
        if(SSL_CTX_load_verify_locations(*p_ctx, ca_path, NULL) != 1)
        {
            //LOG(m_comm, ERROR, "loding CA root file failure.\n");
            //close(*p_sockfd);
            SSL_INIT_ERR = 1;
            return FAIL;
        }
     
        SSL_CTX_set_default_passwd_cb_userdata(*p_ctx, (void *)PASSWD);
        SSL_CTX_set_default_passwd_cb(*p_ctx, password_cb);

        //LOG(m_comm, DEBUG, "loding CA root file ok.\n");
			
        if(SSL_CTX_use_certificate_file(*p_ctx, client_path, SSL_FILETYPE_PEM) != 1)
        {
           // LOG(m_comm, ERROR, "loding client cert file failure.\n");
            //return FAIL;
        }
        else
        {
           // LOG(m_comm, DEBUG, "loding client cert file ok.\n");
        }	

        if(SSL_CTX_use_PrivateKey_file(*p_ctx, key_path, SSL_FILETYPE_PEM) != 1)
        {
          //  LOG(m_comm, ERROR, "loding client key file failure.\n");
            //return FAIL;
        }
        else
        {
           // LOG(m_comm, DEBUG, "loding client key file ok.\n");
        }	

        if(SSL_CTX_check_private_key(*p_ctx) != 1)
        {
           // LOG(m_comm, ERROR, "check private key and cert file failure.\n");
            //return FAIL;
        }
        else
        {
           // LOG(m_comm, DEBUG, "check private key and cert file ok.\n");
        }		

        if((*p_ssl = SSL_new(*p_ctx)) == NULL)
        {
            //LOG(m_comm, ERROR, "create SSL object failure.\n");
            SSL_INIT_ERR = 1;
            return FAIL;
        }
        LOG(m_comm, DEBUG, "create SSL object ok.\n");

        ssl_new_flag = 1;
			
        if(SSL_set_fd(*p_ssl, *p_sockfd) != 1)
        {
            //LOG(m_comm, ERROR, "bind SSL socket failure.\n");
            SSL_INIT_ERR = 1;
            return FAIL;
        }
        //LOG(m_comm, DEBUG, "bind SSL socket ok.\n");
			
        if(SSL_connect(*p_ssl) != 1)
        {
          //  LOG(m_comm, ERROR, "SSL socket connect failure.\n");			
            return FAIL;
        }
       // LOG(m_comm, DEBUG, "SSL socket connect ok.\n");

	if (common_name_check > 1)
	{
		X509 * peerCertificate;

		if(SSL_get_verify_result(*p_ssl) == X509_V_OK)
		{
    			peerCertificate = SSL_get_peer_certificate(*p_ssl);
			if (peerCertificate != NULL)
            			//LOG(m_comm, DEBUG, ">>>>>>>>>get peerCertificate successfully.\n");
		}
		else
		{
    			/* Handle verification error here */
			return FAIL;
		}

		char commonName [512], hostname[512];
		int fd=open_csman(NULL,0);
		X509_NAME * name = X509_get_subject_name(peerCertificate);
		X509_NAME_get_text_by_NID(name, NID_commonName, commonName, 512);

		read_csman(fd, CSID_C_TR069_ACSURL, hostname,sizeof(hostname), CSM_R_ZSTR);
		close_csman(fd);
		/* More in-depth checks of the common name can be used if necessary */
            	//	LOG(m_comm, DEBUG, ">>>>>>>>>common name=%s, hostname=%s.\n", commonName, hostname);

		//if(strcasecmp(commonName, hostname) != 0)
		if (strstr(hostname, commonName) == NULL)
		{
    			/* Handle a suspect certificate here */
            	//	LOG(m_comm, DEBUG, ">>>>>>>>>common name not match.\n");
			return FAIL;
		}
	}
	else
	{
		common_name_check++;
            //	LOG(m_comm, DEBUG, ">>>>>>>>>common name check=%d.\n", common_name_check);
	}
		
        return SUCCESS;
    }
#endif

/*
 *********************************************************************
 * Function name: init_socket_sslv3_mode
 * Description: int and connect to ssl port with sslv3
 * Parameter: char *_ip: the ip address of server; int _port: the port of server; int *p_sockfd: the pointer point to the socket; SSL **p_ssl: the pointer point to the pointer point to the ssl; SSL_CTX **p_ctx: the pointer point to the pointer point to the ssl context; char *ca_path: the ca certificate path; char *client_path: the client certificate path; char *key_path: the key path
 * Return value: 0:SUCCESS  -1:FAIL
 *********************************************************************
*/
#ifdef USE_SSL
    int init_socket_sslv3_mode(char * _ip, int _port, int *p_sockfd, SSL **p_ssl, SSL_CTX **p_ctx, char *ca_path, char *client_path, char *key_path)
    {
        int res;

        struct timeval timeout;
        fd_set fds;
        int errlen;
        int error;
        unsigned long fc;
                                                                                                     
        struct sockaddr_in dest;
                                                                                                 
        bzero(&dest, sizeof(&dest));

        ssl_new_flag = 0;
        ctx_new_flag = 0;
                                                                                                
        dest.sin_family = AF_INET;
        dest.sin_addr.s_addr = inet_addr(_ip);
        dest.sin_port = htons(_port);
        //LOG(m_comm, DEBUG, "set SSL port %d and ip %s.\n", _port, _ip);
                                                                                                 
        fc = 1;
        if(ioctl(*p_sockfd, FIONBIO, &fc) == -1)
        {
           // LOG(m_comm, ERROR, "ioctl error.\n");
            return FAIL;
        }

        if(connect(*p_sockfd, (struct sockaddr *)&dest, sizeof(struct sockaddr)) == -1)
        {
            if(errno != EINPROGRESS) {
                //LOG(m_comm, DEBUG, "Network is unreachable.\n");
                return FAIL;
            }

            errlen = sizeof(int);
            FD_ZERO(&fds);
            FD_SET(*p_sockfd, &fds);
            timeout.tv_sec = TIME_OUT;
            timeout.tv_usec = 0;
                                                                                                 
            if((res = select(*p_sockfd + 1, NULL, &fds, NULL, &timeout)) > 0)
            {
                getsockopt(*p_sockfd, SOL_SOCKET, SO_ERROR, &error, (socklen_t *)&errlen);
                if(error == 0)
                {
                    //LOG(m_comm, DEBUG, "In select()\n");
                }
                else
                {
                  //  LOG(m_comm, ERROR, "error\n");
                    return FAIL;
                }
            }
            else
            {
               // LOG(m_comm, ERROR, "Connect Timeout\n");
                return FAIL;
            }
        }
        else
        {
           // LOG(m_comm, DEBUG, "TCP connected\n");
        }
		
        fc = 0;    
        if(ioctl(*p_sockfd, FIONBIO, &fc) == -1)
        {
            //LOG(m_comm, ERROR, "ioctl error\n");
            return FAIL;
        }
                                                                                                 
        SSL_load_error_strings();
        if(SSL_library_init() != 1)
        {
            //LOG(m_comm, ERROR, "SSL lib init failure.\n");
            return FAIL;
        }
        //LOG(m_comm, DEBUG, "SSL lib init ok.\n");
                                                                                                 
        if((*p_ctx = SSL_CTX_new(SSLv3_method())) == NULL)
        {
           // LOG(m_comm, ERROR, "create SSL context failure.\n");
            return FAIL;
        }
       // LOG(m_comm, DEBUG, "create SSL context ok.\n");

        ctx_new_flag = 1;
                                                                                                    
        SSL_CTX_set_verify(*p_ctx, SSL_VERIFY_PEER, verify_cb);
        SSL_CTX_set_verify_depth(*p_ctx, SSL_DEPTH);
    
        //LOG(m_comm, DEBUG, "set verify mode to SSL_VERIFY_PEER mode.\n");
                                                                                                 
        if(SSL_CTX_load_verify_locations(*p_ctx, ca_path, NULL) != 1)
        {
           // LOG(m_comm, ERROR, "loding CA root file failure.\n");
            return FAIL;
        }
                                                                                                
        SSL_CTX_set_default_passwd_cb_userdata(*p_ctx, (void *)PASSWD);
        SSL_CTX_set_default_passwd_cb(*p_ctx, password_cb);
                                                                                                     
       // LOG(m_comm, DEBUG, "loding CA root file ok.\n");
                                                                                               
        if(SSL_CTX_use_certificate_file(*p_ctx, client_path, SSL_FILETYPE_PEM) != 1)
        {
            //LOG(m_comm, ERROR, "loding client cert file failure.\n");
            //return FAIL;
        }
        else
        {
           // LOG(m_comm, DEBUG, "loding client cert file ok.\n");
        }                                                                                     
                                                                                               
        if(SSL_CTX_use_PrivateKey_file(*p_ctx, key_path, SSL_FILETYPE_PEM) != 1)
        {
           // LOG(m_comm, ERROR, "loding client key file failure.\n");
            //return FAIL;
        }
        else
        {
           // LOG(m_comm, DEBUG, "loding client key file ok.\n");
        }                                                                                    

        if(SSL_CTX_check_private_key(*p_ctx) != 1)
        {
           // LOG(m_comm, ERROR, "check private key and cert file failure.\n");
            //return FAIL;
        }
        else
        {
           // LOG(m_comm, DEBUG, "check private key and cert file ok.\n");
        }                                                                                     

        if((*p_ssl = SSL_new(*p_ctx)) == NULL)
        {
            //LOG(m_comm, ERROR, "create SSL object failure.\n");
            return FAIL;
        }
       // LOG(m_comm, DEBUG, "create SSL object ok.\n");

        ssl_new_flag = 1;
                                                                                                
        if(SSL_set_fd(*p_ssl, *p_sockfd) != 1)
        {
            //LOG(m_comm, ERROR, "bind SSL socket failure.\n");
            return FAIL;
        }
       // LOG(m_comm, DEBUG, "bind SSL socket ok.\n");
                                                                                                 
        if(SSL_connect(*p_ssl) != 1)
        {
           // LOG(m_comm, ERROR, "SSL socket connect failure.\n");
            return FAIL;
        }
        //LOG(m_comm, DEBUG, "SSL socket connect ok.\n");

	if (common_name_check > 1)
	{
		X509 * peerCertificate;

		if(SSL_get_verify_result(*p_ssl) == X509_V_OK)
		{
    			peerCertificate = SSL_get_peer_certificate(*p_ssl);
			if (peerCertificate != NULL)
            		//	LOG(m_comm, DEBUG, ">>>>>>>>>get peerCertificate successfully.\n");
		}
		else
		{
    			/* Handle verification error here */
			return FAIL;
		}

		char commonName [512], hostname[512];
		int fd=open_csman(NULL,0);
		X509_NAME * name = X509_get_subject_name(peerCertificate);
		X509_NAME_get_text_by_NID(name, NID_commonName, commonName, 512);

		read_csman(fd, CSID_C_TR069_ACSURL, hostname,sizeof(hostname), CSM_R_ZSTR);
		close_csman(fd);
		/* More in-depth checks of the common name can be used if necessary */
            	//	LOG(m_comm, DEBUG, ">>>>>>>>>common name=%s, hostname=%s.\n", commonName, hostname);

		//if(strcasecmp(commonName, hostname) != 0)
		if (strstr(hostname, commonName) == NULL)
		{
    			/* Handle a suspect certificate here */
            	//	LOG(m_comm, DEBUG, ">>>>>>>>>common name not match.\n");
			return FAIL;
		}
        }
	else
	{
		common_name_check++;
            	//LOG(m_comm, DEBUG, ">>>>>>>>>common name check=%d.\n", common_name_check);
	}
                                                                                        
        return SUCCESS;
    }
#endif

/*
 *********************************************************************
 * Function name: init_socket_tlsv1_mode
 * Description: int and connect to ssl port with tlsv1
 * Parameter: char *_ip: the ip address of server; int _port: the port of server; int *p_sockfd: the pointer point to the socket; SSL **p_ssl: the pointer point to the pointer point to the ssl; SSL_CTX **p_ctx: the pointer point to the pointer point to the ssl context; char *ca_path: the ca certificate path; char *client_path: the client certificate path; char *key_path: the key path
 * Return value: 0:SUCCESS  -1:FAIL
 *********************************************************************
*/
#ifdef USE_SSL
    int init_socket_tlsv1_mode(char * _ip, int _port, int *p_sockfd, SSL **p_ssl, SSL_CTX **p_ctx, char *ca_path, char *client_path, char *key_path)
    {
        int res;

        struct timeval timeout;
        fd_set fds;
        int errlen;
        int error;
        unsigned long fc;
                                                                                                     
        struct sockaddr_in dest;
                                                                                                 
        bzero(&dest, sizeof(&dest));

        ssl_new_flag = 0;
        ctx_new_flag = 0;
                                                                                                 
        dest.sin_family = AF_INET;
        dest.sin_addr.s_addr = inet_addr(_ip);
        dest.sin_port = htons(_port);
        //LOG(m_comm, DEBUG, "set SSL port %d and ip %s.\n", _port, _ip);
                                                                                                 
        fc = 1;
        if(ioctl(*p_sockfd, FIONBIO, &fc) == -1)
        {
            //LOG(m_comm, ERROR, "ioctl error.\n");
            return FAIL;
        }

        if(connect(*p_sockfd, (struct sockaddr *)&dest, sizeof(struct sockaddr)) == -1)
        {
            if(errno != EINPROGRESS) {
               // LOG(m_comm, DEBUG, "Network is unreachable.\n");
                return FAIL;
            }

            errlen = sizeof(int);
            FD_ZERO(&fds);
            FD_SET(*p_sockfd, &fds);
            timeout.tv_sec = TIME_OUT;
            timeout.tv_usec = 0;
                                                                                                 
            if((res = select(*p_sockfd + 1, NULL, &fds, NULL, &timeout)) > 0)
            {
                getsockopt(*p_sockfd, SOL_SOCKET, SO_ERROR, &error, (socklen_t *)&errlen);
                if(error == 0)
                {
                   // LOG(m_comm, DEBUG, "In select()\n");
                }
                else
                {
                   // LOG(m_comm, ERROR, "error\n");
                    return FAIL;
                }
            }
            else
            {
               // LOG(m_comm, ERROR, "Connect Timeout\n");
                return FAIL;
            }
        }
        else
        {
           // LOG(m_comm, DEBUG, "TCP connected\n");
        }
		
        fc = 0;    
        if(ioctl(*p_sockfd, FIONBIO, &fc) == -1)
        {
           // LOG(m_comm, ERROR, "ioctl error\n");
            return FAIL;
        }
                                                                                                 
        SSL_load_error_strings();
        if(SSL_library_init() != 1)
        {
           // LOG(m_comm, ERROR, "SSL lib init failure.\n");
            return FAIL;
        }
       // LOG(m_comm, DEBUG, "SSL lib init ok.\n");
                                                                                                 
        if((*p_ctx = SSL_CTX_new(TLSv1_method())) == NULL)
        {
            //LOG(m_comm, ERROR, "create SSL context failure.\n");
            return FAIL;
        }
       // LOG(m_comm, DEBUG, "create SSL context ok.\n");

        ctx_new_flag = 1;
                                                                                                     
        SSL_CTX_set_verify(*p_ctx, SSL_VERIFY_PEER, verify_cb);
        SSL_CTX_set_verify_depth(*p_ctx, SSL_DEPTH);
                                                                                                 
       // LOG(m_comm, DEBUG, "set verify mode to SSL_VERIFY_PEER mode.\n");
                                                                                                 
        if(SSL_CTX_load_verify_locations(*p_ctx, ca_path, NULL) != 1)
        {
            //LOG(m_comm, ERROR, "loding CA root file failure.\n");
            return FAIL;
        }
                                                                                                 
        SSL_CTX_set_default_passwd_cb_userdata(*p_ctx, (void *)PASSWD);
        SSL_CTX_set_default_passwd_cb(*p_ctx, password_cb);
                                                                                                 
        LOG(m_comm, DEBUG, "loding CA root file ok.\n");
                                                                                                 
        if(SSL_CTX_use_certificate_file(*p_ctx, client_path, SSL_FILETYPE_PEM) != 1)
        {
            //LOG(m_comm, ERROR, "loding client cert file failure.\n");
            //return FAIL;
        }        
        else
        {
           // LOG(m_comm, DEBUG, "loding client cert file ok.\n");
        }                                                                                         
                                                                                                 
        if(SSL_CTX_use_PrivateKey_file(*p_ctx, key_path, SSL_FILETYPE_PEM) != 1)
        {
            //LOG(m_comm, ERROR, "loding client key file failure.\n");
            //return FAIL;
        }
        else
        {
            //LOG(m_comm, DEBUG, "loding client key file ok.\n");
        }                                                                                         

        if(SSL_CTX_check_private_key(*p_ctx) != 1)
        {
            //LOG(m_comm, ERROR, "check private key and cert file failure.\n");
            //return FAIL;
        }
        else
        {
           // LOG(m_comm, DEBUG, "check private key and cert file ok.\n");
        }                                                                                         

        if((*p_ssl = SSL_new(*p_ctx)) == NULL)
        {
           // LOG(m_comm, ERROR, "create SSL object failure.\n");
            return FAIL;
        }
       // LOG(m_comm, DEBUG, "create SSL object ok.\n");

        ssl_new_flag = 1;
                                                                                                 
        if(SSL_set_fd(*p_ssl, *p_sockfd) != 1)
        {
           // LOG(m_comm, ERROR, "bind SSL socket failure.\n");
            return FAIL;
        }
       // LOG(m_comm, DEBUG, "bind SSL socket ok.\n");
                                                                                                
        if(SSL_connect(*p_ssl) != 1)
        {
            //LOG(m_comm, ERROR, "SSL socket connect failure.\n");
            return FAIL;
        }
       // LOG(m_comm, DEBUG, "SSL socket connect ok.\n");                                        

	if (common_name_check > 1)
	{
		X509 * peerCertificate;

		if(SSL_get_verify_result(*p_ssl) == X509_V_OK)
		{
    			peerCertificate = SSL_get_peer_certificate(*p_ssl);
			if (peerCertificate != NULL)
            		//	LOG(m_comm, DEBUG, ">>>>>>>>>get peerCertificate successfully.\n");
		}
		else
		{
    			/* Handle verification error here */
			return FAIL;
		}

		char commonName [512], hostname[512];
		int fd=open_csman(NULL,0);
		X509_NAME * name = X509_get_subject_name(peerCertificate);
		X509_NAME_get_text_by_NID(name, NID_commonName, commonName, 512);

		read_csman(fd, CSID_C_TR069_ACSURL, hostname,sizeof(hostname), CSM_R_ZSTR);
		close_csman(fd);
		/* More in-depth checks of the common name can be used if necessary */
            	//	LOG(m_comm, DEBUG, ">>>>>>>>>common name=%s, hostname=%s.\n", commonName, hostname);

		//if(strcasecmp(commonName, hostname) != 0)
		if (strstr(hostname, commonName) == NULL)
		{
    			/* Handle a suspect certificate here */
            	//	LOG(m_comm, DEBUG, ">>>>>>>>>common name not match.\n");
			return FAIL;
		}
        }
	else
	{
		common_name_check++;
            //	LOG(m_comm, DEBUG, ">>>>>>>>>common name check=%d.\n", common_name_check);
	}
                                                
        return SUCCESS;
    }
#endif


int dev_get_acs_ip_path(char *url, char *acs_name, char *acs_ip, char *acs_port, char *acs_path, int *flag, int name_flag, int *no_port_flag)
{
    char *p;
    char *ptr;
    char **acs_ip1;
    char str[32];
    char host_buf[128];
    char buf[128];
    char temp_buf[128];
    struct hostent *acs_server;
    char test[100];
    
	

    strcpy(buf, url);

	

    *no_port_flag = 0;

    if (strcmp(buf, "") == 0)
    {
       // LOG(m_comm, ERROR, "The ACS URL is empty\n");
        return FAIL;
    }
    //Begin to get acs ip and path

    p = strstr(buf, "http://");
    if(p == NULL)
    {
        //LOG(m_comm, DEBUG, "There is no \"http://\" in given url.\n");
        
        p = strstr(buf, "https://");

        if(p == NULL)
        {
           // LOG(m_comm, DEBUG, "There is no \"https://\" in given url.\n");
            *flag = -1;
        }
        else
        {
            p = p + 8;
            strcpy(temp_buf, p);
            strcpy(buf, temp_buf);
            *flag = 1;
        }
    }
    else
    {
        p = p + 7;
        strcpy(temp_buf, p);
        strcpy(buf, temp_buf);
        *flag = 0;
    }
    p = strstr(buf, "/");
    if(p == NULL)
    {
        ptr = strstr(buf, ":");
        if(ptr != NULL){
            strncpy(host_buf, buf, (ptr-buf));
            host_buf[ptr-buf] = '\0';
            strcpy(buf, host_buf);
            strcpy(acs_port, ptr+1);
            
        }
        else
        {
            *no_port_flag = 1;

            if(*flag == 0)
                strcpy(acs_port, "80");
            else if(*flag == 1 || *flag == -1)
                strcpy(acs_port, "443");
        }
        
        if(name_flag)
            strcpy(acs_name, buf);

        acs_server = gethostbyname(buf);
        if(acs_server == NULL)
        {
            //LOG(m_comm, ERROR, "gethostbyname unsuccessfully.\n");
            return FAIL;
        }
    
        acs_ip1 = acs_server->h_addr_list;  
   
        strcpy(acs_ip, (char *)inet_ntop(acs_server->h_addrtype, *acs_ip1, str, sizeof(str)));
    }
    else
    {
        ptr = strstr(buf, ":");
        if(ptr != NULL)
        {
            strncpy(host_buf, buf, (ptr-buf));
            host_buf[ptr-buf] = '\0';
            strncpy(acs_port, ptr+1, p-ptr-1);
            acs_port[p-ptr-1] = '\0';
            
        }
        else
        {
            *no_port_flag = 1;

            strncpy(host_buf, buf, (p-buf));
            host_buf[p-buf] = '\0'; 
            if(*flag == 0)
                strcpy(acs_port, "80");
            else if(*flag == 1 || *flag == -1)
                strcpy(acs_port, "443");
        }

        if(name_flag)
            strcpy(acs_name, host_buf);

        acs_server = gethostbyname(host_buf);
        if(acs_server == NULL)
        {
            //LOG(m_comm, ERROR, "gethostname unsuccessfully.\n");
            return FAIL;
        }
        
        acs_ip1 = acs_server->h_addr_list;
        
        strcpy(acs_ip, (char *)inet_ntop(acs_server->h_addrtype, *acs_ip1, str,
sizeof(str)));
    }

    //if(name_flag)
        //LOG(m_comm, DEBUG, "The acs name is %s\n", acs_name);
     sprintf(test,"echo snmp dev_get_acs_ip_path The acs name is %s The acs ip is %s acs_port is %s >>/tmp/colin",acs_name,acs_ip,acs_port);
     system(test);
     memset(test,'\0',sizeof(test));
   // LOG(m_comm, DEBUG, "The acs ip is %s\n", acs_ip);
   // LOG(m_comm, DEBUG, "The acs port is %s\n", acs_port);

    //get acs path
    ptr = strstr(buf, "/");
    if(ptr == NULL)
    {
        strcpy(acs_path, "/");
    }
    else
    {
        strcpy(acs_path, ptr);
    }
    if(acs_path[strlen(acs_path)-1] == '\r') {
        acs_path[strlen(acs_path) - 1] == '\0';
    }
    //LOG(m_comm, DEBUG, "The acs path is %s\n", acs_path);
    sprintf(test,"echo snmp dev_get_acs_ip_path The acs_path is %s >>/tmp/colin",acs_path);
    system(test);
    memset(test,'\0',sizeof(test));

    return SUCCESS;
}
/*
 *********************************************************************
 * Function name: init_socket_http_mode
 * Description: connect to the http port
 * Parameter: char _ip: the ip address of server; int _port: the port of server; int *p_sockfd: the pointer point to the socket
 * Return value: 0:SUCCESS  -1:FAIL
 *********************************************************************
*/
int init_socket_http_mode(char * _ip, int _port, int *p_sockfd)
{
    int res;
   
    struct timeval timeout;
    fd_set fds;
    int errlen;
    int error;
    unsigned long fc;

    struct sockaddr_in dest;

    bzero(&dest, sizeof(&dest));

    dest.sin_family = AF_INET;
    dest.sin_addr.s_addr = inet_addr(_ip);
    //LOG(m_comm, DEBUG, "The http_port: %d\n", _port);
    dest.sin_port = htons(_port);
    //LOG(m_comm, DEBUG, "set HTTP port and ip.\n");
    char test[100];
     sprintf(test,"echo snmp connect_auth 1 >>/tmp/colin");
        system(test);
         memset(test,'\0',sizeof(test));
 	
    fc = 1;
    if(ioctl(*p_sockfd, FIONBIO, &fc) == -1)
    {
        //LOG(m_comm, ERROR, "ioctl error.\n");
         sprintf(test,"echo snmp init_socket_http_mode 1 >>/tmp/colin");
        system(test);
         memset(test,'\0',sizeof(test));
        return FAIL;
    }

    if(connect(*p_sockfd, (struct sockaddr *)&dest, sizeof(struct sockaddr)) == -1)
    {
        if(errno != EINPROGRESS) {
            //LOG(m_comm, DEBUG, "Network is unreachable.\n");
            sprintf(test,"echo snmp init_socket_http_mode 2 >>/tmp/colin");
        system(test);
         memset(test,'\0',sizeof(test));
            return FAIL;
        }

        errlen = sizeof(int);
        FD_ZERO(&fds);
        FD_SET(*p_sockfd, &fds);
        timeout.tv_sec = TIME_OUT;
        timeout.tv_usec = 0;
                                                                                                 
        if((res = select(*p_sockfd + 1, NULL, &fds, NULL, &timeout)) > 0)
        {
            getsockopt(*p_sockfd, SOL_SOCKET, SO_ERROR, &error, (socklen_t *)&errlen);
            if(error == 0)
            {
               // LOG(m_comm, DEBUG, "In select()\n");
            }
            else
            {
                //LOG(m_comm, ERROR, "error\n");
                sprintf(test,"echo snmp init_socket_http_mode 3 >>/tmp/colin");
        system(test);
         memset(test,'\0',sizeof(test));
                return FAIL;
            }
        }
        else
        {
           // LOG(m_comm, ERROR, "Connect Timeout\n");
           sprintf(test,"echo snmp init_socket_http_mode 4 >>/tmp/colin");
        system(test);
         memset(test,'\0',sizeof(test));
            return FAIL;
        }
    }
    else
    {
       // LOG(m_comm, DEBUG, "TCP connected\n");
    }
		
    fc = 0;    
    if(ioctl(*p_sockfd, FIONBIO, &fc) == -1)
    {
       // LOG(m_comm, ERROR, "ioctl error\n");
         sprintf(test,"echo snmp init_socket_http_mode 5 >>/tmp/colin");
        system(test);
         memset(test,'\0',sizeof(test));
        return FAIL;
    }

    return SUCCESS;
}

/*
 *********************************************************************
 * Function name: connect_auth
 * Description: try connect to ACS by SSL or HTTP
 * Parameter: char *_ip: the ip address of server; int _port: the port of server; int *p_sockfd: the pointer point to the socket; SSL **p_ssl: the pointer point to the pointer point to the ssl; SSL_CTX **p_ctx: the pointer point to the pointer point to the ssl context; char *ca_path: the ca certificate path; char *client_path: the client certificate path; char *key_path: the key path; int *p_conn_mode_flag: the pointer point to the connect mode; int *p_conn_mode: the pointer point to the connect mode; int *p_no_port_flag: the pointer point to the no port flag
 * Return value: 0:SUCCESS  -1:FAIL
 *********************************************************************
*/
int connect_auth(char * _ip, int _port, int *p_sockfd, void **p_ssl, void **p_ctx, char *ca_path, char *client_path, char *key_path, int *p_conn_mode_flag, int *p_conn_mode, int *p_no_port_flag)
{
    int res = FAIL;
    char test[100];
    

    if(*p_conn_mode_flag != 0 && *p_conn_mode_flag != 1 && *p_conn_mode_flag != -1)
    {
        //LOG(m_comm, ERROR, "conn flag error.\n");
        sprintf(test,"echo snmp connect_auth 1 >>/tmp/colin");
        system(test);
         memset(test,'\0',sizeof(test));
        return FAIL;
    }

    if(*p_conn_mode_flag == -1 || *p_conn_mode_flag == 1)
    {
        #ifdef USE_SSL
	if (conn_mode_flag == 1 || *p_conn_mode_flag == 1)
	{
        	res = ssl_auth(_ip, _port, p_sockfd, (SSL **)p_ssl, (SSL_CTX **)p_ctx, ca_path, client_path, key_path, p_conn_mode);
        	if(res != SUCCESS)
        	{
            	//	LOG(m_comm, ERROR, "ssl connect failure.\n");
            		if(*p_conn_mode_flag == 1)
            		{
            		    sprintf(test,"echo snmp connect_auth 2 >>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test));
                		return FAIL;
                }
        	}
	}
	else
	{
        	if(*p_conn_mode_flag == 1)
        	{
        	   sprintf(test,"echo snmp connect_auth 3 >>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test));
            		return FAIL;
          }
        	*p_conn_mode = 0;
	}
        #else
        if(*p_conn_mode_flag == 1)
        {
             sprintf(test,"echo snmp connect_auth 4 >>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test));
            return FAIL;
         }
        *p_conn_mode = 0;
        #endif
    }
    else
        *p_conn_mode = 0;

    if(*p_conn_mode != 0 && *p_conn_mode != 1)
    {
        //LOG(m_comm, ERROR, "conn mode error.\n");
         sprintf(test,"echo snmp connect_auth 5 >>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test));
        return FAIL;
    }

    if( *p_conn_mode == 0 )
    {
        if(*p_conn_mode_flag == -1 && *p_no_port_flag == 1)
            _port = 80;

        if((res = init_socket_http_mode(_ip, _port, p_sockfd)) != SUCCESS )
        {
            //destroy_comm_modules_res();

           // LOG(m_comm, ERROR, "init HTTP failure.\n");
            sprintf(test,"echo snmp connect_auth 6 >>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test));

            return FAIL;
        }
        else
        {
           // LOG(m_comm, DEBUG, "init HTTP ok.\n");
        }
    }

    return SUCCESS;
}

/*
 *********************************************************************
 * Function name: sock_send
 * Description: send data
 * Parameter: int p_sockfd: the pointer point to the socket; void **p_ssl: the pointer point to  the pointer point to the ssl; char _pdb: the pointer point to the sending data; int time_out: the timeout time; int mode: the connect mode
 * Return value: 0: SUCCESS; -1, -2, -3, -4: FAIL
 *********************************************************************
*/
int sock_send(int *p_sockfd, void **p_ssl, char * _pdb, int time_out, int mode)
{
    int send_ret_value, result;
    fd_set sendfds;
    struct timeval timeout;

    FD_ZERO(&sendfds);
    FD_SET(*p_sockfd, &sendfds);
    timeout.tv_sec = time_out;
    timeout.tv_usec = 0;

    if(select(*p_sockfd + 1, NULL, &sendfds, NULL, &timeout) > 0)
    {
        if(FD_ISSET(*p_sockfd, &sendfds))
        {
            if(mode == 1)
            {
                #ifdef USE_SSL
		if (conn_mode_flag == 1)
		{
                	send_ret_value = SSL_write(*((SSL **)p_ssl), _pdb, strlen(_pdb));
 
                	if( send_ret_value < strlen(_pdb))
                	{
                    		result = COMM_ERROR_RW;
                	}
                	else
                	{
                    		result = SUCCESS;
                	}
		}
		else
                	result = COMM_ERROR_LIB;
                #else
                result = COMM_ERROR_LIB;
                #endif
                 
            }
            else
            {
                send_ret_value = send(*p_sockfd, _pdb, strlen(_pdb), 0);
 
                if( send_ret_value < strlen(_pdb))
                {
                    result = COMM_ERROR_RW;
                }
                else
                {
                    result = SUCCESS;
                }
            }

        }
        else
        {
            //LOG(m_comm, DEBUG, "FD_ISSET error\n");
            result = COMM_ERROR_FDSET; 
        }
    }
    else 
    {
        //LOG(m_comm, DEBUG, "send timeout\n");
        result = COMM_ERROR_TIMEOUT;
    }

    return result;
}

/*
 *********************************************************************
 * Function name:  sock_recv
 * Description: receive data
 * Parameter: int p_sockfd: the pointer point to the socket; void **p_ssl: the pointer point to  the pointer point to the ssl; char _pdb: the pointer point to the receiving data; int time_out: the timeout time; int mode: the connect mode
 * Return value: 0: SUCCESS; -1, -2, -3, -4: FAIL
 *********************************************************************
*/
int sock_recv(int *p_sockfd, void **p_ssl, char * _pdb, int length, int time_out, int mode)
{
    int recv_ret_value, result;
    fd_set recvfds;
    struct timeval timeout;

    FD_ZERO(&recvfds);
    FD_SET(*p_sockfd, &recvfds);
    timeout.tv_sec = time_out;
    timeout.tv_usec = 0;
                                                                         
    if(select(*p_sockfd + 1, &recvfds, NULL, NULL, &timeout) > 0)
    {
        if(FD_ISSET(*p_sockfd, &recvfds))
        {
            if(mode == 1)
            {
                #ifdef USE_SSL
		if (conn_mode_flag == 1)
		{
                	recv_ret_value = SSL_read(*((SSL **)p_ssl), _pdb, length);

                	if( recv_ret_value < 0 )
                	{
                    		result = COMM_ERROR_RW;
                	}
                	else
                	{
                    		result = recv_ret_value;
                    		if(recv_ret_value > length)
                    		{
                        		_pdb[0] = '\0';
                        		result = COMM_ERROR_RW;
                    		}
                    		else
                    		{
                        		_pdb[recv_ret_value] = '\0';
                    		}
                	}
		}
		else
                	result = COMM_ERROR_LIB;
                #else
                result = COMM_ERROR_LIB;
                #endif
            }
            else
            {
                recv_ret_value = recv(*p_sockfd, _pdb, length, 0);

                if( recv_ret_value < 0 )
                {
                    result = COMM_ERROR_RW;
                }
                else
                {
                    result = recv_ret_value;
                    if(recv_ret_value > length)
                    {
                        _pdb[0] = '\0';
                        result = COMM_ERROR_RW;
                    }
                    else
                    {
                        _pdb[recv_ret_value] = '\0';
                    }
                }
            }
        }
        else 
        {
            //LOG(m_comm, DEBUG, "FD_ISSET error\n");
            result = COMM_ERROR_FDSET;
        }
    }
    else 
    {
        //LOG(m_comm, DEBUG, "recv timeout\n");
        result = COMM_ERROR_TIMEOUT;
    }

    return result;
}



/*
 *********************************************************************
 * Function name: get_file_ser_path
 * Description: get path in given url
 * Parameter: char *url: the whole url; char *path: the result
 * Return value: 0:SUCCESS  -1:FAIL
 *********************************************************************
*/
int get_file_ser_path(char *url, char *path)
{
    char *ptr = NULL;
    char buf[128];
    char temp_buf[128];
   
    strcpy (buf, url); 
    ptr = strstr (buf, "http://");
    if (ptr == NULL) {
        //LOG (m_handler, ERROR, "There is no \"http://\" in url.\n");

        ptr = strstr(buf, "https://");

        if(ptr == NULL)
        {
            //LOG(m_handler, DEBUG, "There is no \"https://\" in given url.\n");
            return FAIL;
        }
        else
        {
            ptr = ptr + 8;
            strcpy(temp_buf, ptr);
            strcpy(buf, temp_buf);
        }
    }
    else
    {
        ptr = ptr + 7;
        strcpy(temp_buf, ptr);
        strcpy(buf, temp_buf);
    }
    
    ptr = strstr (buf, "/");
    if (ptr == NULL) {
        strcpy (path, "/");
        return SUCCESS;
    }
    else {
        strcpy (path, ptr);
        return SUCCESS;
    }
}

/*
 *********************************************************************
 * Function name: get_down_file_name
 * Description: get download file name
 * Parameter: TR_download *param: the pointer pointe to the TR_download structure; char *file_name: the result
 * Return value: 0:SUCCESS  -1:FAIL
 *********************************************************************
*/
void get_down_file_name(SNMP_download *param, char *file_name)
{
    char buf[128];
    char *p = NULL;
    
    strcpy (buf, param->url);
    p = buf;
    p = p + 7;
    p =  strrchr (p, '/');
    if ((p != NULL) && (*(p + 1) != '\0')) {
        strcpy (file_name, p + 1);
    }
    else if (strcmp (param->target_file_name, "")) {
        strcpy (file_name, param->target_file_name);
    }
    else {
        strcpy (file_name, TEMP_FILE_NAME);
    }
  //  LOG (m_handler, DEBUG, "The download file name is %s\n", file_name);

    return;
}

/*
 *********************************************************************
 * Function name: get_digest_param_value
 * Description: get digest authentication parameter value
 * Parameter: char *dg: the digest string; TR_digest_auth *pdigest_auth: the pointer point to the TR_digest_auth structure; char *url: the url; char *user: the username; char *pwd: the password
 * Return value: 0:SUCCESS  -1:FAIL
 *********************************************************************
*/
int get_digest_param_value(char *dg, TR_digest_auth *pdigest_auth, char *url,char *user, char *pwd)
{
    char *pc1 = NULL, *pc2 = NULL;
    char name[50];
    char val[500];
    int res = 0;
    
    pc2 = dg;
    pc1 = strstr (dg, "=");
    
    //This for loop get pszRealm,pszNonce,pszAlg,pszQop values
    while (*pc2 != '\n' && *pc2 != '\r') {
        memset (name, 0, sizeof (name));
        memset (val, 0, sizeof (val));
        
        //get parameter name
        while (*pc2 == ' ') {
            pc2++;
        }
                                                                                                                             
        while (*(pc1 - 1)  == ' ') {
            pc1--;
        }
        
        strncpy (name, pc2, pc1 - pc2);
       // LOG (m_handler, DEBUG, "digest parameter : %s\n", name);
        
        //get parameter value
        pc2 = strstr (pc1, "=");
        pc2++;
        
        while (*pc2 == ' ') {
            pc2++;
        }
        if (*pc2 == '"') {
            pc2++;
            pc1 = strstr (pc2, "\"");
            strncpy (val, pc2, pc1-pc2);
            pc1 = pc1 + 2;
        }
        else {
            pc1 = strstr (pc2, ",");                                                                                                     strncpy (val, pc2, pc1-pc2);
            pc1 = pc1 + 1;
        }
        
        //Move pointer
        pc2 = pc1;
        while (*pc2 == ' ') {
            pc2++;
        }
        pc1 = strstr (pc2, "=");
                                                                                                                                     
        if ( ! strcmp (name, "realm") ) {
            strcpy (pdigest_auth->pszRealm, val);
            continue;
        }
        if ( ! strcmp (name, "nonce") ) {
            strcpy (pdigest_auth->pszNonce, val);
            continue;
        }
        if ( ! strcmp (name, "algorithm") ) {
            strcpy (pdigest_auth->pszAlg, val);
            continue;
        }
        if ( ! strcmp(name, "qop") ) {
            strcpy (pdigest_auth->pszQop, val);
            continue;
        }
        
    }
    
    //get pszCNonce value
    strcpy (pdigest_auth->pszCNonce, "58dde74d9b47ca4f8e410cb170dd47dc");
    
    //get user name value
    strcpy (pdigest_auth->pszUser, user);
    
    //get password value
    strcpy (pdigest_auth->pszPass, pwd);

    if ( ! strcmp(pdigest_auth->pszPass, "") ) {
       // LOG (m_handler, DEBUG, "Password is empty\n");
        return FAIL;
    }
    
    //get szNonceCount value
    strcpy (pdigest_auth->szNonceCount, "00000001");
    
    //get pszMethod value
    strcpy (pdigest_auth->pszMethod, "GET");
    
    //get pszURI value
    res = get_file_ser_path (url, pdigest_auth->pszURI);
    if (res != 0) {
      //  LOG (m_handler, ERROR, "Can't get URI in url in download method.\n");
        return FAIL;
    }

   // LOG (m_handler, DEBUG, "relem is : %s\n, Nonce is : %s\n, pszAlg is : %s\n, pszQop is : %s\n, user is : %s\n, Password is : %s\n, pszURI is : %s\n", pdigest_auth->pszRealm, pdigest_auth->pszNonce, pdigest_auth->pszAlg, pdigest_auth->pszQop, pdigest_auth->pszUser, pdigest_auth->pszPass, pdigest_auth->pszURI);
    
    return SUCCESS;
}

/*
 *********************************************************************
 * Function name: get_auth_info
 * Description: get get authentication information from http head
 * Parameter: char *recvbuf: the pointer point the receive data; char *auth_info: the authentication string; char *url: the url; char *user: the username; char *pwd: the password
 * Return value: 0:SUCCESS  -1:FAIL
 *********************************************************************
*/
int get_auth_info(char *recvbuf, char *auth_info, char *url, char *user, char *pwd)
{
    char *sp = NULL, *dg = NULL;
    int res = 0;
    TR_digest_auth digest_info;
    
    //init auth_head
    memset(auth_info, 0, sizeof(auth_info));
    
    //init digest_auth
    memset (&digest_info, 0, sizeof(TR_digest_auth));
    
    sp = strstr (recvbuf, "WWW-Authenticate");
    if (sp == NULL) {
       // LOG (m_handler, ERROR, "WWW-Authenticate: can't find WWW-Authenticate\n");
        return FAIL;
    }
    
    sp = strtok (sp, " ");
    sp = strtok (NULL, " ");
    
    dg = strtok (NULL, "");
    dg = strtok (dg, "\r\n");
    
  //  LOG (m_handler, DEBUG, "%s\n", dg);
    
    if ( ! strcmp (sp, "Basic") ) {
        return -2;
    }
    if ( ! strcmp (sp, "Digest") ) {
    	//get digest authcation value
    	res = get_digest_param_value (dg, &digest_info, url, user, pwd);
    	if (res != 0) {
    	//    LOG (m_handler, ERROR, "Get digest parameter values failed\n");
    	    return FAIL;
    	}
    	
        get_digest_auth_info (&digest_info, auth_info);
        
       // LOG (m_handler, DEBUG, "Get auth info success, Auth-Head : %s\n", auth_info);
    }       
    return SUCCESS;    
}

/*
 *********************************************************************
 * Function name: dev_download_file
 * Description: download file from server
 * Parameter: TR_download *param: the pointer point to the TR_download structure
 * Return value: 0:SUCCESS  other:FAIL
 *********************************************************************
*/

int dev_download_file(SNMP_download *param)
{
	printf("execute dev_download_file().... \n");
	
    int sockfd, nrecv, f, n, res;
    int i = 0, j = 0, basicflag = 0;
// Change the memory allocation mechanism to dynamic instead of static ..
//    char recvbuf[MAX_DATA_SIZE];
    char *recvbuf;
    char *p = NULL;
    char page[128]; 
    char data[128];
    char sdbuf[1024];
    char tmp_buf[64];
    char file_ser_ip[33];
    char file_ser_port[64];
    char file_ser_name[128];
    
    char input[128];
    char output[128];
    char auth_info[512];
    int length;
    
    int ssl_conn_flag;
    int ssl_conn_mode;
    int dl_no_port_flag;
    #ifdef USE_SSL
    SSL *dl_ssl;
    SSL_CTX *dl_ctx;
    extern int conn_mode_flag;
    #endif

//  change the memory allocation to dynamic
    recvbuf = (char *)malloc(MAX_DATA_SIZE);
   // LOG(m_handler, DEBUG, "malloc recvbuf :%d\n", MAX_DATA_SIZE);  
    memset(recvbuf,0,sizeof(recvbuf));
    //strcpy(param->command_key,"");//test
    //Add
    char *curptr = NULL;
    dl_len = 0;
    int flash_size = 0;
    imageptr = NULL;

    char test[100];
    sprintf(test,"echo snmp dev_download_file 1 >>/tmp/colin");
    system(test);
    memset(test,'\0',sizeof(test));
    //begin
    
    if(param->file_size == 0)
    {
    	//param->file_size = dev_sysflashsizeget () + DOWNLOAD_OVERHEAD;
    	param->file_size = get_flash_free_size() + DOWNLOAD_OVERHEAD;
       // LOG(m_handler, ERROR, ">>>>>>>>>>>>file_size == %d\n", param->file_size);
        //return INTERNAL_ERROR;
    }

    //getflsah size
    //flash_size = dev_sysflashsizeget () + DOWNLOAD_OVERHEAD;
    flash_size = get_flash_free_size() + DOWNLOAD_OVERHEAD;
    //Judge have the enough space to store the file
	  sprintf(test,"echo snmp dev_download_file 2 flash_size=%d >>/tmp/colin",flash_size);
    system(test);
    memset(test,'\0',sizeof(test));
	//felix add
	//flash_size = 8000000;
	//end
	
   // LOG (m_handler, DEBUG, "Device flash size is : %d\n", flash_size);

    if (param->file_size > flash_size) {
        //LOG (m_handler, ERROR, "File Size is over by %d\n", param->file_size - flash_size);
//        dlclose(handle);
        sprintf(test,"echo snmp dev_download_file 2a >>/tmp/colin");
        system(test);
        memset(test,'\0',sizeof(test));
        return REQUEST_DENY;
    }

    //LOG (m_handler, DEBUG, "Download start with len = %d with flash size = %d\n", param->file_size, flash_size);
     sprintf(test,"echo snmp Download start with len = %d with flash size = %d >>/tmp/colin",param->file_size,flash_size);
        system(test);
        memset(test,'\0',sizeof(test));
    //END ADD
 
    memset (recvbuf, 0 , sizeof(recvbuf));
 ///*
    res = dev_get_acs_ip_path(param->url, file_ser_name, file_ser_ip, file_ser_port, page, &ssl_conn_flag, 1, &dl_no_port_flag);
    if(res != 0)
    {
        // LOG (m_handler, ERROR, "Get file server ip and name unsuccessfully\n");
//         dlclose(handle);
        sprintf(test,"echo snmp dev_download_file 2aa >>/tmp/colin");
        system(test);
        memset(test,'\0',sizeof(test));
         return INTERNAL_ERROR;
    }
   // */
   // LOG(m_handler, DEBUG, "The ssl flag is %d\n", ssl_conn_flag);
    
    get_down_file_name (param, tmp_buf);
    sprintf(test,"echo snmp dev_download_file p1 >>/tmp/colin");
        system(test);
        memset(test,'\0',sizeof(test));
    if ((sockfd = socket (AF_INET, SOCK_STREAM, 0))== -1) {
       // LOG (m_handler, ERROR, "Create Socket Unsuccessfully\r\n");
//        dlclose(handle);
        sprintf(test,"echo snmp dev_download_file 3a >>/tmp/colin");
        system(test);
        memset(test,'\0',sizeof(test));
        return INTERNAL_ERROR;
    }
     sprintf(test,"echo snmp dev_download_file p2 file_ser_name=%s >>/tmp/colin",file_ser_name);
     system(test);
     memset(test,'\0',sizeof(test));
  ///*  colin
     #ifdef USE_SSL
     if (conn_mode_flag == 1 || ssl_conn_flag == 1)
     {
        res = connect_auth(file_ser_ip, atoi(file_ser_port), &sockfd, (void **)(&dl_ssl), (void **)(&dl_ctx), ca_cert_path, client_cert_path, client_key_path, &ssl_conn_flag, &ssl_conn_mode, &dl_no_port_flag);
  //  LOG(m_handler, DEBUG, ">>>>>>>>>>>>Download with SSL, ca_cert_path = %s\n", ca_cert_path);
     }
     else
        res = connect_auth(file_ser_ip, atoi(file_ser_port), &sockfd, NULL, NULL, NULL, NULL, NULL, &ssl_conn_flag, &ssl_conn_mode, &dl_no_port_flag); 
    #else
        res = connect_auth(file_ser_ip, atoi(file_ser_port), &sockfd, NULL, NULL, NULL, NULL, NULL, &ssl_conn_flag, &ssl_conn_mode, &dl_no_port_flag); 
    #endif

   // LOG(m_handler, DEBUG, ">>>>>>>>>>>>Download flag is %d, conn_mode is %d\n", ssl_conn_flag, ssl_conn_mode);
 
    if(res != SUCCESS)
    {
       // LOG (m_handler, ERROR, "Download connect auth Unsuccessfully\r\n");
//        dlclose(handle);
        close(sockfd);
        sprintf(test,"echo snmp dev_download_file 4a >>/tmp/colin");
        system(test);
        memset(test,'\0',sizeof(test));
        return INTERNAL_ERROR;
    }
    //LOG (m_handler, ERROR, "Download connect auth successfully\r\n");
  // */ 
    if (!strcmp(param->username, "") || !strcmp(param->password, "")) {
        sprintf (sdbuf,"GET %s HTTP/1.1\r\n", page);
        sprintf (data, "Host: %s\r\n", file_ser_name);
        strcat (sdbuf, data);
        strcat (sdbuf, "Accept: */*\r\n");
        strcat (sdbuf, "User-Agent: Mozilla/4.0\r\n");
        strcat (sdbuf, "Pragma: no-cache\r\n");
        strcat (sdbuf, "Cache-Control: no-cache\r\n");
        strcat (sdbuf, "Connection: close\r\n");
        strcat (sdbuf, "\r\n\0");
       // LOG (m_handler, DEBUG, "Now the sendbuf is\n%s\n", sdbuf); 
     sprintf(test,"echo snmp dev_download_file p3 >>/tmp/colin");
        system(test);
        memset(test,'\0',sizeof(test));                
        //Send
        #ifdef USE_SSL
     	if (conn_mode_flag == 1)
            res = sock_send(&sockfd, (void **)(&dl_ssl), sdbuf, DOWN_TIME_OUT, ssl_conn_mode);
	else
            res = sock_send(&sockfd, NULL, sdbuf, DOWN_TIME_OUT, ssl_conn_mode);
        #else
            res = sock_send(&sockfd, NULL, sdbuf, DOWN_TIME_OUT, ssl_conn_mode);
        #endif
 
        if(res != SUCCESS)
        {
          //  LOG (m_handler, ERROR, "Send unsuccessfully\r\n");
            if(ssl_conn_mode != 0)
            {
                #ifdef USE_SSL
                destroy_ssl_res(&dl_ssl, &dl_ctx);
                #endif
            }
 
            close (sockfd);
//            dlclose(handle);
             sprintf(test,"echo snmp dev_download_file 5a >>/tmp/colin");
             system(test);
             memset(test,'\0',sizeof(test));
            return INTERNAL_ERROR;
        }
       // LOG (m_handler, DEBUG, "Send success!\r\n");
        
        //Recevie
        while (1) {
            #ifdef USE_SSL
     	    if (conn_mode_flag == 1)
                nrecv = sock_recv(&sockfd, (void**)(&dl_ssl), recvbuf, MAX_DATA_SIZE, DOWN_TIME_OUT , ssl_conn_mode);
	    else
                nrecv = sock_recv(&sockfd, NULL, recvbuf, MAX_DATA_SIZE, DOWN_TIME_OUT, ssl_conn_mode);
            #else
                nrecv = sock_recv(&sockfd, NULL, recvbuf, MAX_DATA_SIZE, DOWN_TIME_OUT, ssl_conn_mode);
            #endif
	   // LOG (m_handler, DEBUG, "nrecv = %d, success = %d, i = %d\r\n", nrecv, SUCCESS, i);
		        
		        sprintf(test,"echo snmp dev_download_file 5aa nrecv=%d >>/tmp/colin",nrecv);
             system(test);
             memset(test,'\0',sizeof(test));
		 
            switch(nrecv)
            {
                case SUCCESS:
                    sprintf(test,"echo snmp dev_download_file sock_recv SUCCESS nrecv=%d >>/tmp/colin",nrecv);
                      system(test);
                      memset(test,'\0',sizeof(test));
                    break;
                case COMM_ERROR_RW:
                 //   LOG (m_handler, ERROR, "Recv data from file server unsuccessfully\r\n");
                    if(ssl_conn_mode != 0)
                    {
                        #ifdef USE_SSL
                        destroy_ssl_res(&dl_ssl, &dl_ctx);
                        #endif
                    }
 
                    close (sockfd);
//                    dlclose(handle);
                      sprintf(test,"echo snmp dev_download_file DOWNLOAD_FAILURE nrecv=%d >>/tmp/colin",nrecv);
                      system(test);
                      memset(test,'\0',sizeof(test));
                    return DOWNLOAD_FAILURE;

                case COMM_ERROR_LIB:
                    if(ssl_conn_mode != 0)
                    { 
                        #ifdef USE_SSL 
                        destroy_ssl_res(&dl_ssl, &dl_ctx);
                        #endif
                    }

                    close (sockfd);
//                    dlclose(handle);
                     sprintf(test,"echo snmp dev_download_file INTERNAL_ERROR 1 nrecv=%d >>/tmp/colin",nrecv);
                      system(test);
                      memset(test,'\0',sizeof(test));
                    return INTERNAL_ERROR;
                case COMM_ERROR_FDSET:
                   // LOG (m_handler, ERROR, "FD_ISSET error!\r\n");
                    if(ssl_conn_mode != 0)
                    { 
                        #ifdef USE_SSL 
                        destroy_ssl_res(&dl_ssl, &dl_ctx);
                        #endif
                    }

                    close (sockfd);
//                    dlclose(handle);
                      sprintf(test,"echo snmp dev_download_file INTERNAL_ERROR 2 nrecv=%d >>/tmp/colin",nrecv);
                      system(test);
                      memset(test,'\0',sizeof(test));
                    return INTERNAL_ERROR;
                case COMM_ERROR_TIMEOUT:
                   // LOG (m_handler, DEBUG, "Receive error (maybe timeout).\r\n");
                    if(ssl_conn_mode != 0)
                    { 
                        #ifdef USE_SSL 
                        destroy_ssl_res(&dl_ssl, &dl_ctx);
                        #endif
                    }
                    close (sockfd);
//                    dlclose(handle);
                      sprintf(test,"echo snmp dev_download_file DOWNLOAD_FAILURE 2 nrecv=%d >>/tmp/colin",nrecv);
                      system(test);
                      memset(test,'\0',sizeof(test));
                    return DOWNLOAD_FAILURE;
            }

            if (i == 0) {
                if ( strstr (recvbuf, "200 OK") == NULL ) {
                   // LOG (m_handler, ERROR, "Download file unsuccessfully\n.");
                      sprintf(test,"echo snmp dev_download_file 6aa Download file unsuccessfully>>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test));
                    if(ssl_conn_mode != 0)
                    { 
                        #ifdef USE_SSL 
                        destroy_ssl_res(&dl_ssl, &dl_ctx);
                        #endif
                    }

                    close (sockfd);
//                    dlclose(handle);
                    sprintf(test,"echo snmp dev_download_file 6a DOWNLOAD_FAILURE>>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test));
                    return DOWNLOAD_FAILURE;
                }
                //ADD
                //Judge if download firmware
                if (strcmp (param->file_type, "1 Firmware Upgrade Image") == 0) {
                    //dev_killallapps();
                    
                    sprintf(test,"echo snmp dev_download_file killall ap >>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test));
#ifdef TC3262
                    system("echo 3 > /proc/sys/vm/drop_caches");
                   // LOG (m_handler, DEBUG, "Done removing processes, echo 3\n");
		    system("echo \" \
		              [ -e /var/run/web-rebinding.pid ] && kill \\\`cat /var/run/web-rebinding.pid\\\` ; \
		              killall -9 wscd             ; \
		              killall -9 watchdog-touch   ; \
		              watchdog-touch -d           ; \
		              rmmod -f ralink_wdt         ; \
		          \" > /tmp/killall-wdt.sh ; sh /tmp/killall-wdt.sh & ");
                  //  LOG (m_handler, DEBUG, "Done kill watchdog\n");
#endif
                }
               // LOG (m_handler, DEBUG, "Allocating %d bytes buffer\n", param->file_size);
                sprintf(test,"echo snmp dev_download_file Allocating %d bytes buffer >>/tmp/colin",param->file_size);
                system(test);
                memset(test,'\0',sizeof(test));

                curptr = (char *)malloc(param->file_size);
  //  LOG(m_handler, DEBUG, "malloc curptr :%d\n", param->file_size);  
                sprintf(test,"echo snmp dev_download_file param->file_size =%d >>/tmp/colin",param->file_size);
                system(test);
                memset(test,'\0',sizeof(test));
                if (curptr == NULL) {
                 //   LOG (m_handler, ERROR, "Failed to allocate memory for the image. size required : [%d].\n", 
              //      param->file_size);
//                    dlclose(handle);
                     sprintf(test,"echo snmp dev_download_file 7a >>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test));
                    return INTERNAL_ERROR;
                }
                imageptr = curptr;
              //  LOG (m_handler, DEBUG, "Memory allocated %d\n", param->file_size);
                sprintf(test,"echo snmp dev_download_file Memory allocated %d >>/tmp/colin",param->file_size);
                system(test);
                memset(test,'\0',sizeof(test));
                //END ADD
                        
                if (((p = strstr(recvbuf, "\r\n\r\n")) != NULL) || ((p = strstr(recvbuf, "\n\r\n\r")) != NULL)) {
                    p = p + 4;
                    n = nrecv-(p-recvbuf);
                    if (n != 0) {
                        //strcpy(recvbuf, p);
                    }
                    recvbuf[MAX_DATA_SIZE] = '\0';
                }
                else {                           
                   // LOG (m_handler, ERROR, "Can't find the begining of data.\n");
                    if(ssl_conn_mode != 0)
                    { 
                        #ifdef USE_SSL 
                        destroy_ssl_res(&dl_ssl, &dl_ctx);
                        #endif
                    }

                    close (sockfd);
                    free(imageptr);
  //  LOG(m_handler, DEBUG, "free imageptr:%d\n", sizeof(imageptr));
//                    dlclose(handle);
                    sprintf(test,"echo snmp dev_download_file 8a >>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test));
                    return DOWNLOAD_FAILURE;                            
                }
                    
                //ADD
                if (n != 0) {
                    memcpy (curptr, p, n);
                    curptr += n;
                    dl_len += n;
                    if (dl_len > param->file_size) {
                       // LOG(m_handler, ERROR, "Falied on Over size image\n");
                        close(sockfd);
                        free(imageptr);
    //LOG(m_handler, DEBUG, "free imageptr:%d\n", sizeof(imageptr));
//                        dlclose(handle);
                         sprintf(test,"echo snmp dev_download_file 9a copy data error >>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test));
                        return INTERNAL_ERROR;
                    }
                }
                //END ADD

            }
            else {   //i != 0 
                //ADD
                memcpy (curptr, recvbuf, nrecv);
                curptr += nrecv;
                dl_len += nrecv;
                if (dl_len > param->file_size) {
                    //LOG (m_handler, ERROR, "Failed on over size image\n");
                    close(sockfd);
                    free(imageptr);
  //  LOG(m_handler, DEBUG, "free imageptr:%d\n", sizeof(imageptr));
//                    dlclose(handle);
                      sprintf(test,"echo snmp dev_download_file 10a copy data error >>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test)); 
                    return INTERNAL_ERROR;
                }
                //END ADD
            }
            i = 1;
            //LOG (m_handler, DEBUG, "The size of recv data is %d\r\n", nrecv);
            if (nrecv == 0)
                break;
        }
    }
    else {
    	  sprintf (sdbuf,"GET %s HTTP/1.1\r\n", page);
        sprintf (data, "Host: %s\r\n", file_ser_name);
        strcat (sdbuf, data);
        strcat (sdbuf, "Accept: */*\r\n");
        strcat (sdbuf, "User-Agent: Mozilla/4.0\r\n");
        strcat (sdbuf, "Pragma: no-cache\r\n");
        strcat (sdbuf, "Cache-Control: no-cache\r\n");
        strcat (sdbuf, "Connection: close\r\n");
        
        sprintf (input, "%s:%s", param->username, param->password);

        //Encode "username:password" using base64
  //colin      length = Base64Enc ((unsigned char *)output, (const unsigned char *)input, strlen(input));
       // LOG (m_handler, DEBUG, "The encoded string is %s length of %d\n", output, length);
        sprintf (auth_info, "Authorization: Basic %s", output);
        
        strcat (sdbuf, auth_info);
        strcat (sdbuf, "\015\012\015\012\0");
       // LOG (m_handler, DEBUG, "Now the sendbuf is\n%s\n", sdbuf);
               
        //Send
        #ifdef USE_SSL
     	if (conn_mode_flag == 1)
            res = sock_send(&sockfd, (void **)(&dl_ssl), sdbuf, DOWN_TIME_OUT, ssl_conn_mode);
	else
            res = sock_send(&sockfd, NULL, sdbuf, DOWN_TIME_OUT, ssl_conn_mode);
        #else
            res = sock_send(&sockfd, NULL, sdbuf, DOWN_TIME_OUT, ssl_conn_mode);
        #endif

        if(res != SUCCESS)
        {
           // LOG (m_handler, ERROR, "Send unsuccessfully\r\n");
            if(ssl_conn_mode != 0)
            { 
                #ifdef USE_SSL 
                destroy_ssl_res(&dl_ssl, &dl_ctx);
                #endif
            }

            close (sockfd);
//            dlclose(handle);
              sprintf(test,"echo snmp dev_download_file 11a >>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test)); 
            return INTERNAL_ERROR;
        }
       // LOG (m_handler, DEBUG, "Send success!\r\n");
        
        //Receive
        while (1) {
            #ifdef USE_SSL
     	    if (conn_mode_flag == 1)
                nrecv = sock_recv(&sockfd, (void**)(&dl_ssl), recvbuf, MAX_DATA_SIZE, DOWN_TIME_OUT , ssl_conn_mode);
	    else
                nrecv = sock_recv(&sockfd, NULL, recvbuf, MAX_DATA_SIZE, DOWN_TIME_OUT, ssl_conn_mode);
            #else
                nrecv = sock_recv(&sockfd, NULL, recvbuf, MAX_DATA_SIZE, DOWN_TIME_OUT, ssl_conn_mode);
            #endif

            switch(nrecv)
            {
                case SUCCESS:
                    break;
                case COMM_ERROR_RW:
                  //  LOG (m_handler, ERROR, "Recv data from file server unsuccessfully\r\n");
                    if(ssl_conn_mode != 0)
                    { 
                        #ifdef USE_SSL 
                        destroy_ssl_res(&dl_ssl, &dl_ctx);
                        #endif
                    }

                    close (sockfd);
//                    dlclose(handle);
                     sprintf(test,"echo snmp dev_download_file 12a DOWNLOAD_FAILURE >>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test)); 
                    return DOWNLOAD_FAILURE;

                case COMM_ERROR_LIB:
                    if(ssl_conn_mode != 0)
                    { 
                        #ifdef USE_SSL 
                        destroy_ssl_res(&dl_ssl, &dl_ctx);
                        #endif
                    }

                    close (sockfd);
//                    dlclose(handle);
                     sprintf(test,"echo snmp dev_download_file 13a INTERNAL_ERROR >>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test)); 
                    return INTERNAL_ERROR;
                case COMM_ERROR_FDSET:
                  //  LOG (m_handler, ERROR, "FD_ISSET error!\r\n");
                    if(ssl_conn_mode != 0)
                    { 
                        #ifdef USE_SSL 
                        destroy_ssl_res(&dl_ssl, &dl_ctx);
                        #endif
                    }

                    close (sockfd);
//                    dlclose(handle);
                     sprintf(test,"echo snmp dev_download_file 14a INTERNAL_ERROR >>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test)); 
                    return INTERNAL_ERROR;
                case COMM_ERROR_TIMEOUT:
                  //  LOG (m_handler, DEBUG, "Receive error (maybe timeout).\r\n");
                    if(ssl_conn_mode != 0)
                    { 
                        #ifdef USE_SSL 
                        destroy_ssl_res(&dl_ssl, &dl_ctx);
                        #endif
                    }

                    close (sockfd);
//                    dlclose(handle);
                     sprintf(test,"echo snmp dev_download_file 15a DOWNLOAD_FAILURE >>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test)); 
                    return DOWNLOAD_FAILURE;
            }

            if (i == 0) {
                if (strstr(recvbuf, "401 Unauthorized") != NULL || strstr(recvbuf, "401 Authorization Required") != NULL) {
                    if(ssl_conn_mode != 0)
                    {
                        #ifdef USE_SSL
                        destroy_ssl_res(&dl_ssl, &dl_ctx);
                        #endif
                    }

                    close(sockfd);
                    basicflag = 1;
                    break;                         
                }
                else {  //There is no 401 in http head
                    if (strstr(recvbuf, "200 OK") == NULL) {
                    //    LOG(m_handler, DEBUG, "recvbuf = %s\n", recvbuf);
                    //    LOG (m_handler, ERROR, "Download file unsuccessfully\n.");
                        if(ssl_conn_mode != 0)
                        { 
                            #ifdef USE_SSL 
                            destroy_ssl_res(&dl_ssl, &dl_ctx);
                            #endif
                        }

                        close (sockfd);
//                        dlclose(handle);
                         sprintf(test,"echo snmp dev_download_file 16a DOWNLOAD_FAILURE >>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test)); 
                        return DOWNLOAD_FAILURE;
                    }
                    //ADD
                    //Judge if download firmware
                    if (strcmp(param->file_type, "1 Firmware Upgrade Image") == 0) {
                        //dev_killallapps();
#ifdef TC3262
                        system("echo 3 > /proc/sys/vm/drop_caches");
                     //   LOG(m_handler, DEBUG, "Done removing processes, echo 3\n");
		    system("echo \" \
		              [ -e /var/run/web-rebinding.pid ] && kill \\\`cat /var/run/web-rebinding.pid\\\` ; \
		              killall -9 wscd             ; \
		              killall -9 watchdog-touch   ; \
		              watchdog-touch -d           ; \
		              rmmod -f ralink_wdt         ; \
		          \" > /tmp/killall-wdt.sh ; sh /tmp/killall-wdt.sh & ");
                 //   LOG (m_handler, DEBUG, "Done kill watchdog\n");
#endif
                    }
                  //  LOG(m_handler, DEBUG, "Allocating %d bytes buffer\n", param->file_size);

                    curptr = (char *)malloc(param->file_size);
  //  LOG(m_handler, DEBUG, "malloc curptr :%d\n", param->file_size);  
                    if (curptr == NULL) {
                       // LOG (m_handler, ERROR, "Failed to allocate memory for the image. size required : [%d].\n", param->file_size);
//                        dlclose(handle);
                          sprintf(test,"echo snmp dev_download_file 17a INTERNAL_ERROR >>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test)); 
                        return INTERNAL_ERROR;
                    }
                    imageptr = curptr;
                  //  LOG (m_handler, DEBUG, "Memory allocated %d\n", param->file_size);
                    //END ADD
                            
                    if (((p = strstr(recvbuf, "\r\n\r\n")) != NULL) || ((p = strstr(recvbuf, "\n\r\n\r")) != NULL)) {
                        p = p + 4;
                        n = nrecv-(p-recvbuf);
                        if (n != 0) {
                            //strcpy(recvbuf, p);
                        }
                        recvbuf[MAX_DATA_SIZE] = '\0';
                    }
                    else {                       
                    //    LOG (m_handler, ERROR, "Can't find the begining of data.\n");
                        if(ssl_conn_mode != 0)
                        { 
                            #ifdef USE_SSL 
                            destroy_ssl_res(&dl_ssl, &dl_ctx);
                            #endif
                        }

                        close (sockfd);
                        free(imageptr);
 //   LOG(m_handler, DEBUG, "free imageptr:%d\n", sizeof(imageptr));
//                        dlclose(handle);
                          sprintf(test,"echo snmp dev_download_file 18a DOWNLOAD_FAILURE >>/tmp/colin");
                    system(test);
                    memset(test,'\0',sizeof(test)); 
                        return DOWNLOAD_FAILURE;
                    }
                    
                    if (n != 0) {
                        memcpy (curptr, p, n);
                        curptr += n;
                        dl_len += n;
                        sprintf(test,"echo snmp dev_download_file 19a dl_len=%d >>/tmp/colin",dl_len);
                             system(test);
                             memset(test,'\0',sizeof(test));
                        if (dl_len > param->file_size) {
                          //  LOG(m_handler, ERROR, "Failed on over size image\n");
                            close(sockfd);
                            free(imageptr);
//    LOG(m_handler, DEBUG, "free imageptr:%d\n", sizeof(imageptr));
//                            dlclose(handle);
                             sprintf(test,"echo snmp dev_download_file 19a copy data error >>/tmp/colin");
                             system(test);
                             memset(test,'\0',sizeof(test)); 
                            return INTERNAL_ERROR;
                        }
                    }
                    //END ADD
                }
            }
            else
            {
                //ADD
                memcpy(curptr, recvbuf, nrecv);
                curptr += nrecv;
                dl_len += nrecv;
                sprintf(test,"echo snmp dev_download_file 20a dl_len=%d >>/tmp/colin",dl_len);
                             system(test);
                             memset(test,'\0',sizeof(test)); 
                if (dl_len > param->file_size) {
                 //   LOG (m_handler, ERROR, "Failed on over size image\n");
                    close(sockfd);
                    free(imageptr);
  //  LOG(m_handler, DEBUG, "free imageptr:%d\n", sizeof(imageptr));
//                    dlclose(handle);
                      sprintf(test,"echo snmp dev_download_file 20a INTERNAL_ERROR >>/tmp/colin");
                             system(test);
                             memset(test,'\0',sizeof(test)); 
                    return INTERNAL_ERROR;
                }
                //END ADD
            }
            i = 1;
   //         LOG (m_handler, DEBUG, "The size of recv data is %d\r\n", nrecv);
            if (nrecv == 0)
                break;               
        }
        // Digest Authentication
        if (basicflag == 1) {
      //      LOG (m_handler, DEBUG, "The recvbuf is \n%s\n", recvbuf);
        
            if ((sockfd = socket(AF_INET, SOCK_STREAM, 0))== -1) {
          //      LOG (m_handler, ERROR, "Create Socket Unsuccessfully\r\n");
//                dlclose(handle);
                  sprintf(test,"echo snmp dev_download_file 21a INTERNAL_ERROR >>/tmp/colin");
                             system(test);
                             memset(test,'\0',sizeof(test)); 
                return INTERNAL_ERROR;
            }
    
            #ifdef USE_SSL
     	    if (conn_mode_flag == 1)
                res = connect_auth(file_ser_ip, atoi(file_ser_port), &sockfd, (void **)(&dl_ssl), (void **)(&dl_ctx), ca_cert_path, client_cert_path, client_key_path, &ssl_conn_flag, &ssl_conn_mode, &dl_no_port_flag);
	    else
                res = connect_auth(file_ser_ip, atoi(file_ser_port), &sockfd, NULL, NULL, NULL, NULL, NULL, &ssl_conn_flag, &ssl_conn_mode, &dl_no_port_flag); 
            #else
                res = connect_auth(file_ser_ip, atoi(file_ser_port), &sockfd, NULL, NULL, NULL, NULL, NULL, &ssl_conn_flag, &ssl_conn_mode, &dl_no_port_flag); 

             //   LOG(m_handler, DEBUG, "Download flag is %d, conn_mode is %d\n", ssl_conn_flag, ssl_conn_mode);
            #endif
 
            if(res != SUCCESS)
            {
               // LOG (m_handler, ERROR, "Download connect auth Unsuccessfully\r\n");

                /*if(ssl_conn_mode != 0)
                {
                    #ifdef USE_SSL
                    destroy_ssl_res(&dl_ssl, &dl_ctx);
                    #endif
                }*/
                close(sockfd);

//                dlclose(handle);
                  sprintf(test,"echo snmp dev_download_file 22a INTERNAL_ERROR >>/tmp/colin");
                             system(test);
                             memset(test,'\0',sizeof(test)); 
                return INTERNAL_ERROR;
            }
         //   LOG (m_handler, ERROR, "Download connect auth successfully\r\n");
    /*    // colin 
            f = get_auth_info (recvbuf, auth_info, param->url, param->username, param->password);
            if (f != SUCCESS) {
                if (f == -2) {
                   // LOG(m_handler, ERROR, "Basic authentication unsuccessfully\n");
                    if(ssl_conn_mode != 0)
                    {
                        #ifdef USE_SSL
                        destroy_ssl_res(&dl_ssl, &dl_ctx);
                        #endif
                    }

                    close(sockfd);
//                    dlclose(handle);
                    return FILE_TRAN_AUTH_FAIL;
                }
                else {
             	  //  LOG(m_handler, ERROR, "Get authorization information unsuccessfully\n");
                    if(ssl_conn_mode != 0)
                    {
                        #ifdef USE_SSL
                        destroy_ssl_res(&dl_ssl, &dl_ctx);
                        #endif
                    }

             	    close(sockfd);
//                    dlclose(handle);
                    return INTERNAL_ERROR;
                }
            }
            */ // colin 
            sprintf(sdbuf,"GET %s HTTP/1.1\r\n", page);
            sprintf(data, "Host: %s\r\n", file_ser_name);
            strcat(sdbuf, data);
            strcat(sdbuf, "Accept: */*\r\n");
            strcat(sdbuf, "User-Agent: Mozilla/4.0\r\n");
            strcat(sdbuf, "Pragma: no-cache\r\n");
            strcat(sdbuf, "Cache-Control: no-cache\r\n");
            strcat(sdbuf, "Connection: close\r\n");
            
            strcat(sdbuf, auth_info);
            strcat(sdbuf, "\r\n\r\n\0");
           // LOG(m_handler, DEBUG, "Now the sendbuf is\n%s\n", sdbuf);
            
            //Send
            #ifdef USE_SSL
     	    if (conn_mode_flag == 1)
                res = sock_send(&sockfd, (void **)(&dl_ssl), sdbuf, DOWN_TIME_OUT, ssl_conn_mode);
	    else
                res = sock_send(&sockfd, NULL, sdbuf, DOWN_TIME_OUT, ssl_conn_mode);
            #else
                res = sock_send(&sockfd, NULL, sdbuf, DOWN_TIME_OUT, ssl_conn_mode);
            #endif
 
            if(res != SUCCESS)
            {
               // LOG (m_handler, ERROR, "Send unsuccessfully\r\n");
                if(ssl_conn_mode != 0)
                { 
                    #ifdef USE_SSL 
                    destroy_ssl_res(&dl_ssl, &dl_ctx);
                    #endif
                }

                close (sockfd);
//                dlclose(handle);
                   sprintf(test,"echo snmp dev_download_file 23a INTERNAL_ERROR >>/tmp/colin");
                             system(test);
                             memset(test,'\0',sizeof(test)); 
                return INTERNAL_ERROR;
            }
          //  LOG (m_handler, DEBUG, "Send success!\r\n");
            
            //Receive
            while (1) {
                #ifdef USE_SSL
     	    	if (conn_mode_flag == 1)
                    nrecv = sock_recv(&sockfd, (void**)(&dl_ssl), recvbuf, MAX_DATA_SIZE, DOWN_TIME_OUT , ssl_conn_mode);
		else
                    nrecv = sock_recv(&sockfd, NULL, recvbuf, MAX_DATA_SIZE, DOWN_TIME_OUT, ssl_conn_mode);
                #else
                    nrecv = sock_recv(&sockfd, NULL, recvbuf, MAX_DATA_SIZE, DOWN_TIME_OUT, ssl_conn_mode);
                #endif

                switch(nrecv)
                {
                    case SUCCESS:
                        break;
                    case COMM_ERROR_RW:
                      //  LOG (m_handler, ERROR, "Recv data from file server unsuccessfully\r\n");
                        if(ssl_conn_mode != 0)
                        { 
                            #ifdef USE_SSL 
                            destroy_ssl_res(&dl_ssl, &dl_ctx);
                            #endif
                        }

                        close (sockfd);
//                        dlclose(handle);
                         sprintf(test,"echo snmp dev_download_file 24a INTERNAL_ERROR >>/tmp/colin");
                             system(test);
                             memset(test,'\0',sizeof(test)); 
                        return INTERNAL_ERROR;

                    case COMM_ERROR_LIB:
                        if(ssl_conn_mode != 0)
                        { 
                            #ifdef USE_SSL 
                            destroy_ssl_res(&dl_ssl, &dl_ctx);
                            #endif
                        }

                        close (sockfd);
//                        dlclose(handle);
                            sprintf(test,"echo snmp dev_download_file 25a INTERNAL_ERROR >>/tmp/colin");
                             system(test);
                             memset(test,'\0',sizeof(test)); 
                        return INTERNAL_ERROR;
                    case COMM_ERROR_FDSET:
                       // LOG (m_handler, ERROR, "FD_ISSET error!\r\n");
                        if(ssl_conn_mode != 0)
                        { 
                            #ifdef USE_SSL 
                            destroy_ssl_res(&dl_ssl, &dl_ctx);
                            #endif
                        }

                        close (sockfd);
//                        dlclose(handle);
                          sprintf(test,"echo snmp dev_download_file 26a INTERNAL_ERROR >>/tmp/colin");
                             system(test);
                             memset(test,'\0',sizeof(test)); 
                        return INTERNAL_ERROR;
                    case COMM_ERROR_TIMEOUT:
                       // LOG (m_handler, DEBUG, "Receive error (maybe timeout).\r\n");
                        if(ssl_conn_mode != 0)
                        { 
                            #ifdef USE_SSL 
                            destroy_ssl_res(&dl_ssl, &dl_ctx);
                            #endif
                        }

                        close (sockfd);
//                        dlclose(handle);
                           sprintf(test,"echo snmp dev_download_file 27a DOWNLOAD_FAILURE >>/tmp/colin");
                             system(test);
                             memset(test,'\0',sizeof(test)); 
                        return DOWNLOAD_FAILURE;
                }

                if (j == 0) {
                    if (strstr(recvbuf, "200 OK") == NULL) {
                        if (strstr(recvbuf, "401 Unauthorized") != NULL) {
                        //    LOG(m_handler, ERROR, "Digest authentication unsccessfully.\n");
                            if(ssl_conn_mode != 0)
                            {
                                #ifdef USE_SSL
                                destroy_ssl_res(&dl_ssl, &dl_ctx);
                                #endif
                            }

                            close(sockfd);
//                            dlclose(handle);
                               sprintf(test,"echo snmp dev_download_file 28a FILE_TRAN_AUTH_FAIL >>/tmp/colin");
                             system(test);
                             memset(test,'\0',sizeof(test)); 
                            return FILE_TRAN_AUTH_FAIL;
                        }
                        else {
                         //   LOG(m_handler, ERROR, "Download file unsuccessfully.\n.");
                            if(ssl_conn_mode != 0)
                            {
                                #ifdef USE_SSL
                                destroy_ssl_res(&dl_ssl, &dl_ctx);
                                #endif
                            }

                            close(sockfd);
//                            dlclose(handle);
                             sprintf(test,"echo snmp dev_download_file 29a DOWNLOAD_FAILURE >>/tmp/colin");
                             system(test);
                             memset(test,'\0',sizeof(test));
                            return DOWNLOAD_FAILURE;
                        }
                    }
                    //ADD
                    //Judge if download firmware
                    if (strcmp(param->file_type, "1 Firmware Upgrade Image") == 0) {
                        //dev_killallapps();
#ifdef TC3262
                        system("echo 3 > /proc/sys/vm/drop_caches");
                       // LOG(m_handler, DEBUG, "Done removing processes, echo 3\n");
		    system("echo \" \
		              [ -e /var/run/web-rebinding.pid ] && kill \\\`cat /var/run/web-rebinding.pid\\\` ; \
		              killall -9 wscd             ; \
		              killall -9 watchdog-touch   ; \
		              watchdog-touch -d           ; \
		              rmmod -f ralink_wdt         ; \
		          \" > /tmp/killall-wdt.sh ; sh /tmp/killall-wdt.sh & ");
                   // LOG (m_handler, DEBUG, "Done kill watchdog\n");
#endif
                    }
                 //   LOG(m_handler, DEBUG, "Allocating %d bytes buffer\n", param->file_size);

                    curptr = (char *)malloc(param->file_size);
   // LOG(m_handler, DEBUG, "malloc curptr :%d\n", param->file_size);  
                    if (curptr == NULL) {
                       // LOG(m_handler, ERROR, "Failed to allocate memory for the image. size required : [%d].\n", param->file_size);
//                        dlclose(handle);
                        sprintf(test,"echo snmp dev_download_file 30a INTERNAL_ERROR >>/tmp/colin");
                             system(test);
                             memset(test,'\0',sizeof(test));
                        return INTERNAL_ERROR;
                    }
                    imageptr = curptr;
                  //  LOG(m_handler, DEBUG, "Memory allocated %d\n", param->file_size);
                    //END ADD
                             
                    if(((p = strstr(recvbuf, "\r\n\r\n")) != NULL) || ((p = strstr(recvbuf, "\n\r\n\r")) != NULL)) {
                        p = p + 4;
                                                
                        n = nrecv-(p-recvbuf);
                        if(n != 0){
                            //strcpy(recvbuf, p);
                        }
                        recvbuf[MAX_DATA_SIZE] = '\0';
                    }
                    else {                                               
                      //  LOG(m_handler, ERROR, "Can't find the begining of data.\n");
                        if(ssl_conn_mode != 0)
                        {
                            #ifdef USE_SSL
                            destroy_ssl_res(&dl_ssl, &dl_ctx);
                            #endif
                        }

                        close(sockfd);
                        free(imageptr);
  //  LOG(m_handler, DEBUG, "free imageptr:%d\n", sizeof(imageptr));
//                        dlclose(handle);
                          sprintf(test,"echo snmp dev_download_file 31a DOWNLOAD_FAILURE >>/tmp/colin");
                             system(test);
                             memset(test,'\0',sizeof(test));
                        return DOWNLOAD_FAILURE;
                    }
                    
                    //ADD
                    if (n != 0) {
                        memcpy(curptr, p, n);
                        curptr += n;
                        dl_len += n;
                        sprintf(test,"echo snmp dev_download_file 32a dl_len=%d >>/tmp/colin",dl_len);
                    system(test);
                    memset(test,'\0',sizeof(test));
                        if (dl_len > param->file_size) {
                           // LOG(m_handler, ERROR, "Filed over on size\n");
                            close(sockfd);
                            free(imageptr);
  //  LOG(m_handler, DEBUG, "free imageptr:%d\n", sizeof(imageptr));
//                            dlclose(handle);
                             sprintf(test,"echo snmp dev_download_file 32a INTERNAL_ERROR >>/tmp/colin");
                             system(test);
                             memset(test,'\0',sizeof(test));
                            return INTERNAL_ERROR;
                        }
                    }
                    //END ADD

                }
                else {   // j != 0
                    //ADD
                    memcpy(curptr, recvbuf, nrecv);
                    curptr += nrecv;
                    dl_len += nrecv;
                    sprintf(test,"echo snmp dev_download_file 33a dl_len=%d >>/tmp/colin",dl_len);
                    system(test);
                    memset(test,'\0',sizeof(test));
                    if (dl_len > param->file_size) {
                   //     LOG(m_handler, ERROR, "Failed over on size\n");
                        close(sockfd);
                        free(imageptr);
 //   LOG(m_handler, DEBUG, "free imageptr:%d\n", sizeof(imageptr));
//                        dlclose(handle);
                          sprintf(test,"echo snmp dev_download_file 33a INTERNAL_ERROR >>/tmp/colin");
                             system(test);
                             memset(test,'\0',sizeof(test));
                        return INTERNAL_ERROR;
                    }
                    //END ADD
                }
                j = 1;

                //LOG(m_handler, DEBUG, "The size of recv data is %d\n", nrecv);
                if(nrecv == 0)
                    break;                 
            }
        }
    }
                              
    if(ssl_conn_mode != 0)
    {
        #ifdef USE_SSL
        destroy_ssl_res(&dl_ssl, &dl_ctx);
        #endif
    }

    close(sockfd);

    //ADD
 //   LOG(m_handler, DEBUG, ">>>>>>>>>>>>>>>>>>>>>>>Download size is : %d\n", dl_len);
    
    //Parse Image Data
    if ((strcmp(param->file_type, "1 Firmware Upgrade Image") == 0) || (strcmp(param->file_type, "1") == 0) ) {
      //  LOG(m_handler, DEBUG, "File type is 1 firmware upgrade image, will call function parse image data\n");
        //imagetype = dev_parseimagedata(imageptr, dl_len, TRF_DOWNLOAD_IMAGE);
        imagetype = parse_data(imageptr, dl_len, TRF_DOWNLOAD_IMAGE);
        
        sprintf(test,"echo snmp dev_download_file  Parse Image Data imagetype=%d dl_len=%d >>/tmp/colin",imagetype,dl_len);
                             system(test);
                             memset(test,'\0',sizeof(test));
    }
    else {
        if ((strcmp(param->file_type, "2 Web Content") == 0)||(strcmp(param->file_type, "2") == 0)) {
            //imagetype = dev_parseimagedata(imageptr, dl_len, TRF_DOWNLOAD_WEB);
            imagetype = parse_data(imageptr, dl_len, TRF_DOWNLOAD_WEB);
        }
        else {
            if ((strcmp(param->file_type, "3 Vendor Configuration File") == 0)||(strcmp(param->file_type, "3") == 0)) {
           //     LOG(m_handler, DEBUG, "The file type is 3 vendor configuration file, will call parse image data function\n");
               // imagetype = dev_parseimagedata(imageptr, dl_len, TRF_DOWNLOAD_SETTINGS);
                imagetype = parse_data(imageptr, dl_len, TRF_DOWNLOAD_SETTINGS);
            }
            else {
            //    LOG(m_handler, ERROR, "The invalid file type : %s\n", param->file_type);
                free(imageptr);
//    LOG(m_handler, DEBUG, "free imageptr:%d\n", sizeof(imageptr));
//                dlclose(handle);
                   sprintf(test,"echo snmp dev_download_file 34a INVALID_ARGUMENT >>/tmp/colin");
                             system(test);
                             memset(test,'\0',sizeof(test));
                return INVALID_ARGUMENT;
            }
        }
    }

    if (imagetype == NO_FORMAT) {
 //       LOG(m_handler, DEBUG, "Invalid file\n");
        free(imageptr);
//    LOG(m_handler, DEBUG, "free imageptr:%d\n", sizeof(imageptr));
//        dlclose(handle);
        //return DOWNLOAD_FAILURE;
          sprintf(test,"echo snmp dev_download_file 35a FILE_CORRUPTED >>/tmp/colin");
                             system(test);
                             memset(test,'\0',sizeof(test));
        return DOWNLOAD_FAILURE;
    }


//===new add===========================//

        //Add
        if (imagetype == CONFIG_FORMAT)
        {
          
        }
        else if (imagetype == WEB_FORMAT)
        {
       
        }
        else if (imagetype == IMAGE_FORMAT)
        {
         
            if (dev_flashimage_func(imageptr, dl_len) != 0)
            {
              //  LOG(m_handler, DEBUG, "Write flash image failed\n");
                //eeror code? define
              //  transfer->fault_struct.fault_code = 9002;
              //  strcpy(transfer->fault_struct.fault_string, "Internal error");
	           }
	    
         
        }
               
      //  LOG(m_handler, DEBUG, "Success download then will reboot system\n");

        reboot_dev();

   // }
    //*/
//===new add===========================//



    return SUCCESS;
}
