/*
 * Copyright(c) 2006-2007, Works Systems, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 3. Neither the name of the vendors nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


/*
 * Prevent multiple inclusion...
 */
 
#ifndef HANDLER_H_
#define HANDLER_H_
/*
 * Include head file
 */

#include <errno.h>


#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <resolv.h>    

#include <unistd.h>
#include <dlfcn.h>



//libupgbuf.so
/*
 * Define return value
 */

#define INIT_HANDLE_SUCCESS 0
#define INIT_HANDLE_FAILED  -1


//=====colin add=======//

#define SYSTEMPASSWORD			1
#define FIRMWAREFILENAME		2
#define FIRMWAREVERSION			3
#define ACCEPTUNOFFICIALFW		4
#define TIMEZONE				5
#define AUTOSYNCENABLE			6
#define AUTOSYNCTIMESERVER		7
#define DAYLIGHTSAVINGENABLE	8
#define BACKUPSETTING			9
#define RESETTODEFAULT			10
#define REBOOT					11
#define WAKEONLANMACADDR		12
#define PINGTESTADDR			13
#define TRACEROUTEADDR			14
#define FIRMWAREFILEPATH		15
#define MAX_DATA_SIZE 20480 
#define MTHD_NOT_SUPPORT     9000
#define REQUEST_DENY         9001
#define INTERNAL_ERROR       9002
#define INVALID_ARGUMENT     9003
#define RESOURCE_EXCEED      9004
#define INVALID_PARAM_NAME   9005
#define INVALID_PARAM_TYPE   9006
#define INVALID_PARAM_VAL    9007
#define SET_NOT_WRITEABLE    9008
#define NOTIFY_REQ_REJECT    9009
#define DOWNLOAD_FAILURE     9010
#define UPLOAD_FAILURE       9011
#define FILE_TRAN_AUTH_FAIL  9012
#define UNSUPPORT_PROTOCOL   9013
#define FILE_CORRUPTED       9018

#define UNKNOW_MTHD          9800
#define TOO_MANY_ENV         9801
#define STR_TOO_LONG         9802
#define INVALID_TIME_ZONE    9803

#define RETRY_REQUEST        8005
#define SUCCESS  0
#define ERROR  -1
#define FAIL   -1
#ifdef USE_SSL
       	#define PASSWD "passwd" // the password of client.key
#endif
#define COMM_SSL_ERROR -2
#define COMM_ERROR_RW -1
#define COMM_ERROR_LIB -2
#define COMM_ERROR_FDSET -3
#define COMM_ERROR_TIMEOUT -4

#define first_reboot  0         // 1 -- first reboot before download, 0 -- first download before reboot
#define filesize      100       // The size of the file which will be download
#define delayseconds  10        // The number of seconds from the time this method id called to the 
//#define delayseconds  10        // The number of seconds from the time this method id called to the 
                                // time the cpe is request to init the download
#define MAX_DATA_SIZE 20480 
#define TEMP_FILE_NAME "download_file"
#define DOWN_TIME_OUT 15

#define TRF_DOWNLOAD_IMAGE 0
#define TRF_DOWNLOAD_WEB   1
#define TRF_DOWNLOAD_SETTINGS 2

#define DOWNLOAD_OVERHEAD 256
#define MIN_DOWNLOAD_LEN 2048

#define NO_FORMAT 0
#define IMAGE_FORMAT 1
#define WEB_FORMAT 2
#define CONFIG_FORMAT 3
#define DEV_LENGTH   50
#define TIME_OUT 30
#define FAULT_STRING_LEN 256
#define COMMAND_KEY_LEN 32
#define PATH_LEN         100
/*download&tasklist*/
char dl_conf_path[PATH_LEN];

char dev_lib_path[DEV_LENGTH];    //save dll lib name

char dev_factoryreset_func[DEV_LENGTH];
char dev_diagnostic_func[DEV_LENGTH];
char dev_sys_cmd[DEV_LENGTH];
char ca_cert_path[DEV_LENGTH];
char client_cert_path[DEV_LENGTH];
char client_key_path[DEV_LENGTH];

void *flash_handle;

//======colin add=============//


/*
 * Data types...
 */

typedef struct download
{
    char   command_key[33];
    char   file_type[65];
    char   url[257];
    char   username[257];
    char   password[257];
    unsigned int   file_size;
    char   target_file_name[257];
    unsigned int   delay_seconds;
    char   success_url[257];
    char   failure_url[257];
}SNMP_download;

char *imageptr;
int dl_len;
int imagetype;

int download_at_once_flag;

/*
 * macrodefinition
 */
 

/* 
 * Prototypes
 */
 //=====colin add=================//
 
 int dev_get_acs_ip_path(char *url, char *acs_name, char *acs_ip, char *acs_port, char *acs_path, int *flag, int name_flag, int *no_port_flag);
 int init_socket_http_mode(char * _ip, int _port, int *p_sockfd);
 int sock_send(int *p_sockfd, void **p_ssl, char * _pdb, int time_out, int mode);
 int sock_recv(int *p_sockfd, void **p_ssl, char * _pdb, int length, int time_out, int mode);
 int connect_auth(char * _ip, int _port, int *p_sockfd, void **p_ssl, void **p_ctx, char *ca_path, char *client_path, char *key_path, int *p_conn_mode_flag, int *p_conn_mode, int *p_no_port_flag);
 
 int get_flash_free_size();
 int parse_data(char *image_start_ptr, int bufsize, int dl_type);
 int dev_flashimage_func(char *imageptr, int imagelen); 
 int reboot_dev();
 
 #ifdef USE_SSL
    SSL * ssl;
    SSL_CTX * ctx;
    int ssl_new_flag;
    int ctx_new_flag;
#endif
#ifndef SSL_PORT
    #define SSL_PORT 443
#endif

#ifndef SSL_DEPTH
    #define SSL_DEPTH 3
#endif

#ifndef TIME_OUT
    #define TIME_OUT 30
#endif
 
 #ifdef USE_SSL
    #include <openssl/crypto.h>
    #include <openssl/ssl.h>
    #include <openssl/ssl23.h>
    #include <openssl/ssl2.h>

    int SSL_INIT_ERR;
    int ssl_auth(char * _ip, int _port, int *p_sockfd, SSL **p_ssl, SSL_CTX **p_ctx, char *ca_path, char *client_path, char *key_path, int *p_flag);
    int init_socket_ssl_mode(char * _ip, int _port, int *p_socket, SSL **p_ssl, SSL_CTX **p_ctx, char *ca_path, char *client_path, char *key_path);
    int init_socket_sslv3_mode(char * _ip, int _port, int *p_socket, SSL **p_ssl, SSL_CTX **p_ctx, char *ca_path, char *client_path, char *key_path);
    int init_socket_tlsv1_mode(char * _ip, int _port, int *p_socket, SSL **p_ssl, SSL_CTX **p_ctx, char *ca_path, char *client_path, char *key_path);
    void destroy_ssl_res(SSL **p_ssl, SSL_CTX **p_ctx);
#endif



#endif  /* HANDLER_H_ */
